REM CRYPTO05 - RANDOM NUMBERS                                     (1 AUG 95)

'              THIS PROGRAM PRODUCES 10 SETS OF PSEUDO-RANDOM NUMBERS THAT
'              ARE TO BE USED IN C/27 AND C/28 FOR PRODUCTION OF ROTORS USED
'              IN ENIGMA95.BAS - ENIGMA-95 CIPHER MACHINE

  OPTION BASE 1

  DIM A$(100)    ' ROTOR 1
  DIM B$(100)    ' ROTOR 2
  DIM C$(100)    ' ROTOR 3
  DIM D$(100)    ' ROTOR 4
  DIM E$(100)    ' ROTOR 5
  DIM F$(100)    ' ROTOR 6
  DIM G(100)     ' ROTOR BUILDING ARRAY
  DIM G$(100)    ' ROTOR 7
  DIM H$(100)    ' ROTOR 8
  DIM I$(100)    ' ROTOR 9
  DIM J$(100)    ' ROTOR 10
  DIM N$(100)    ' MONITOR DISPLAY ARRAY (10 x 10)
 
  A = 0: B = 0: C = 0
  ROTOR$ = STRING$(200, "0")
  R1 = 21

  CLS

  LOCATE 5, 16
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "WELCOME TO CRYPTO05 - RANDOM NUMBERS GENERATOR"
 
  LOCATE 22, 30
  COLOR 12, 0                         'RED/BLACK
  PRINT "Clarence E. Tyner Jr."
  LOCATE 23, 15
  PRINT "Copyrighted 1995 - All Rights Reserved Worldwide."
  COLOR 7, 0                          'WHITE/BLACK
 
  T2 = 1

  LOCATE 10, 25: INPUT ; "   ENTER 1ST RANDOM NUMBER  ", A
  LOCATE 12, 25: INPUT ; "   ENTER 2ND RANDOM NUMBER  ", B
  LOCATE 14, 25: INPUT ; "   ENTER 3RD RANDOM NUMBER  ", C
  LOCATE 16, 25: INPUT ; "   PAUSE BETWEEN SETS (Y or N) "; P1$

200 :                                 'INITIALIZE
  FOR Z = 1 TO 100: G(Z) = 0: N$(Z) = " ": NEXT Z
  Z2 = 0
  CLS

230 :                                 'CREATE RANDOM NUMBERS
  D = (A / B - INT(A / B)) + (B / A - INT(B / A)) ^ C
  E = ((C + INT(A / B) + INT(B / A)) ^ D) / (F + 1)
  F = INT(((D * E) - INT(D * E)) * 100) + 1

  IF F = 0 THEN GOTO 620                'IF ZERO THEN MAKE NEW RANDOM NUMBERS
  X = 0

  LOCATE 17, 26
  PRINT "GENERATED NUMBER = "; F

360 :
  X = X + 1
  IF G(X) = 0 THEN GOTO 400
  IF G(X) = F THEN GOTO 620           'MAKE NEW RANDOM NUMBERS
  GOTO 360

400 :
  G(X) = F
  LOCATE 3, 28
  COLOR 14, 0
  PRINT "SET "; K + 1; " BEING CONSTRUCTED"
  COLOR 7, 0
  PRINT
  IF F <= 100 THEN GOTO 460
  F = 100

460 :
  N$(F) = STR$(F - 1)
  I1$ = "\\"
  Y2 = 25
  FOR Y = 1 TO 10
    LOCATE Y + 5, Y2
      FOR Y1 = 1 TO 10
        PRINT USING "\ \"; N$(((Y - 1) * 10) + Y1);
      NEXT Y1
      PRINT
  NEXT Y

  H = H + 1
  H1 = H1 + 1
  LOCATE 19, 26
  PRINT USING "FILLED COUNT = ### "; H


  IF H1 * 3 = 63 THEN
     R1 = R1 + 1
     H1 = 1
     END IF
  IF R1 = 26 THEN R1 = 21

  F1$ = "00"
  IF F < 10 THEN
    MID$(F1$, 2, 1) = MID$(STR$(F), 2, 1)
    END IF
  IF F > 9 AND F < 100 THEN
    F1$ = MID$(STR$(F), 2, 2)
    END IF
  LOCATE R1, (H1 * 3) + 6
  PRINT USING "\ \"; F1$;

IF H = 100 THEN
  IF P1$ = "Y" THEN
     SLEEP
     GOTO 660
  ELSE
     GOTO 660
     END IF
  END IF

620 :
  A = A + (D ^ .51) + RND(1)
  B = B + (E ^ .33) + RND(1)
  C = C + (F ^ 1.7) + RND(1)

  GOTO 230

660 :
  K = K + 1
  R = 21
  H = 0
  FOR L = 1 TO 100
    G(L) = G(L) - 1
    P$ = STR$(G(L))
    MID$(P$, 1, 1) = "0"
    IF G(L) < 10 THEN Q$ = MID$(P$, 1, 2)
    IF G(L) > 9 THEN Q$ = MID$(P$, 2, 2)

  SELECT CASE K
    CASE 1
      A$(L) = Q$
    CASE 2
      B$(L) = Q$
    CASE 3
      C$(L) = Q$
    CASE 4
      D$(L) = Q$
    CASE 5
      E$(L) = Q$
    CASE 6
      F$(L) = Q$
    CASE 7
      G$(L) = Q$
    CASE 8
      H$(L) = Q$
    CASE 9
      I$(L) = Q$
    CASE 10
      J$(L) = Q$
  END SELECT

  NEXT L

  IF K <> 10 THEN GOTO 200

  LPRINT : LPRINT CHR$(27); "!"; CHR$(52);         '---EMPHASIZED PRINTING
  LPRINT "                   RANDOM NUMBERS"
  LPRINT : LPRINT

  I2$ = "No.   01   02   03   04   05   06   07   08   09   10"
  I3$ = "###   \ \  \ \  \ \  \ \  \ \  \ \  \ \  \ \  \ \  \ \"
  I4$ = "---   --   --   --   --   --   --   --   --   --   --"

  LPRINT I2$
  LPRINT I4$
  LPRINT

  FOR L = 1 TO 100
    LPRINT USING I3$; L; A$(L); B$(L); C$(L); D$(L); E$(L); F$(L); G$(L); H$(L); I$(L); J$(L)
    LPRINT
  NEXT L

  LPRINT I4$
  LPRINT I2$

  LPRINT CHR$(27); "F";               'DEACTIVATE EMPHASIZED PRINTING

END

