REM CRYPTO27 - ROTOR CREATION USING INTERVAL METHOD              (32 AUG 95)

'              FOR UP TO A 100 POSITION REGULAR ROTOR (CAN BE VARIED BY
'              SETTING THE VALUE OF 'H' IN THE PROGRAM BELOW).
'
'              REVERSING ROTORS ARE MADE USING C/34.          
'
'              THIS PROGRAM DETERMINES THE 'FROM' AND 'TO' CONNECTIONS
'              OF A ROTOR SO THAT THE DISTANCES (INTERVALS) BETWEEN THESE
'              POINTS EVENLY ASSIGNED FROM 0 TO MAXIMUM.  ONE INTERVAL IS
'              SKIPPED AND ONE INTERVAL OCCURS TWICE.

'              IT OFFERS 3 MODES OF KEYBOARD INPUT AND 1 AUTOMATIC INPUT:

'              A - KEYBOARD : TERMINAL(TO) ONLY.  THIS IS THE FASTEST BUT
'                  IS NOT FLEXIBLE IN THAT IT SELECTS ORIGIN (FROM) POSITIONS
'                  AUTOMATICALLY AND SEQUENTIALLY STARTING AT POSITION 1.
'                  (MODE 1)  NOT ALL POSITIONS CAN BE CONNECTED AND MODE 2
'                  WOULD ALSO HAVE TO BE USED.

'              B - KEYBOARD : ALLOWS SELECTION OF BOTH 'FROM' AND 'TO'
'                  POSITIONS BUT DOES NOT ALLOW CLEARING OF PREVIOUSLY
'                  SELECTED POSITIONS.  (MODE 2)

'              C - KEYBOARD : ALLOWS DELETION OF PREVIOUSLY SELECTED
'                  POSITIONS TO PERMIT TRIAL-AND-ERROR EXPERIMENTATION TO
'                  FINISH THE ASSIGNMENT SESSION.   (MODE 3)

'              D - AUTOMATIC : SAME AS No. 1 BUT OBTAINS INPUT FROM DATA
'                  STATEMENTS. IT IS ACCESSED THROUGH MODE 1 AND IS USED
'                  ONLY AS A DEMONSTRATION. THERE ARE 3 DATA SETS TO
'                  CHOOSE FROM.

'              E - AUTOMATIC : THIS IS THE SAME AS MODE 3 AND IS ACCESSED
'                  THROUGH MODE 4.  IT WILL AUTOMATICALLY TRY ALTERNATE
'                  ASSIGNMENTS UNTIL 99 POSITIONS ARE FILLED (ASSUMING A
'                  100 POSITION ROTOR).  AT THAT TIME THE LAST UNFILLED
'                  POSITION IS MANUALLY FILLED (AND THEN PRINTED ON PAPER).
'                  (MODE 4)

'              START WITH MODE 1 UNTIL ALL ENTRIES ARE REJECTED.  THEN USE
'              MODE 2 UMTIL ALL ENTRIES ARE REJECTED.

'              THEN USE MODE 3 AND MODE 2 IN COMBINATION UNTIL ONLY ONE
'              CONNECTION IS NEEDED.
'recommended
'------------> OR, START WITH MODE 1 THEN USE MODE 4 TO DO IT AUTOMATICALLY
'              FROM THERE ON UNTIL 99 POSITIONS ARE FILLED. (JUST SIT BACK
'              AND WATCH)   THE LAST ONE WILL BE THE CONNECTION WITH THE
'              DUPLICATED INTERVAL (TO BE FILLED MANUALLY IN OPTION 6).

'              THE ROTOR MAY BE PRINTED USING MODE 5, OR, IF YOU ARE USING
'              OPTION 4, BY ENTERING '9999' WHEN OPTION 4 IS COMPLETED.

'              THE ROTOR MAY BE SAVED TO A FLOPPY DISK BY USING MODE 6.
'              THE ROTORS ON THE DISK MAY BE DISPLAYED BY USING MODE 6.

'              TO CREATE A REVERSING ROTOR: USE CRYPTO34.BAS

'----------------------------------------------------------------------------

OPTION BASE 1
CLS

  CLS
  LOCATE 4, 16
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "Welcome to the CRYPTO27 - Regular Rotor Generator"
  COLOR 7, 0                          'WHITE/BLACK

  COLOR 12, 0                         'RED/BLACK
  LOCATE 20, 5
  PRINT TAB(26); "By  Clarence E. Tyner Jr."
  LOCATE 21, 5
  PRINT TAB(15); "Copyright 1995  - All Rights Reserved Worldwide"
  COLOR 7, 0


  LOCATE 10, 17

LOCATE 12, 23
INPUT "ENTER ROTOR SIZE (MAX. 100) : ", H

CLS

DIM A(100)                            'INTERVALS - ORDERED SEQUENCE
DIM F(100)                            'FROM POSITION - (FRONT OF ROTOR)
DIM I(100)                            'INTERVALS - ALIGNED WITH F() AND T()
DIM T(100)                            'TO POSITION - ALIGNED WITH F()
DIM U(100)                            'TO POSITIONS SELECTED (ORDERED)

ROTOR$ = STRING$(200, "0")

FOR Y = 1 TO 100                      'FILL ROTOR POSITIONS
  F(Y) = Y                            'FROM POSITIONS (FRONT SIDE OF ROTOR)
  T(Y) = 200                          'TO POSITIONS (REVERSE SIDE OF ROTOR)
  I(Y) = 200                          'INTERVALS BETWEEN F(Y) AND T(Y)
  A(Y) = 200                          'I(Y) IN SEQUENTIAL ORDER
NEXT Y

T$ = " F  I  T  U  A  "               'COLUMN HEADINGS FOR SCREEN DISPLAY
Z8 = 6000                             'PAUSE BETWEEN BEEPS


                                      'DATA STATEMENTS USED FOR DEMO RUNS
                                      'CODE 300 = END OF READ DATA FILE
                                      'CODE 400 = BLANK
DATA1:
  DATA 022,052,034,002,019,058,100,012,083,011
  DATA 082,099,013,077,027,018,020,098,079,055
  DATA 080,021,015,056,009,033,097,081,045,400
  DATA 050,001,095,024,014,008,084,096,093,091
  DATA 089,010,086,035,006,057,004,003,078,025
  DATA 061,067,036,074,037,062,094,088,005,026
  DATA 039,090,044,049,038,007,076,085,066,047
  DATA 059,017,029,041,040,065,053,042,073,075
  DATA 023,031,400,028,400,400,092,400,400,030
  DATA 087,400,032,400,400,400,400,400,400,400
  DATA 300

DATA2:
  DATA 065,084,021,029,015,022,094,098,090,007
  DATA 020,066,080,061,073,054,040,044,023,064
  DATA 089,010,099,095,097,001,088,012,077,042
  DATA 058,078,039,036,004,096,092,003,033,047
  DATA 063,055,006,014,031,060,086,026,083,009
  DATA 081,005,074,011,070,085,048,082,062,052
  DATA 056,045,043,038,050,400,400,400,400,400
  DATA 400,400,400,400,400,400,400,400,400,400
  DATA 400,400,400,400,400,400,400,400,400,400
  DATA 400,400,400,400,400,400,400,400,400,400
  DATA 300

DATA3:
  DATA 058,028,056,040,080,078,005,092,049,031
  DATA 014,093,030,077,062,064,079,025,013,022
  DATA 041,065,029,043,039,051,019,073,002,001
  DATA 042,083,094,008,069,004,007,066,057,084
  DATA 026,054,044,009,068,085,052,034,003,046
  DATA 027,010,017,070,037,023,006,038,059,097
  DATA 091,071,095,088,096,032,045,018,082,053
  DATA 061,099,081,012,016,036,400,024,048,067
  DATA 033,011,072,063,076,021,075,087,086,100
  DATA 050,047,035,098,090,089,074,020,055,015
  DATA 300


CLS

START:

  LPRINT CHR$(27); "@";               'INITIALIZE PRINTER
  WIDTH LPRINT 160                    'SET LINE WIDTH TO 160 COLUMNS
  LPRINT CHR$(27); "Q"; CHR$(162);    'SET RIGHT MARGIN TO 162 COLUMNS
  LPRINT CHR$(27); "k"; CHR$(1);      'SANS SERIF FONT
  LPRINT CHR$(27); "M";               'ELITE PRINT
  LPRINT CHR$(27); "E";               'EMPHASIZED (BOLD) PRINTING


X = 0: T = 0: I = 0: A1 = 0
J = 0: F = 0

CLS
PRINT : PRINT : PRINT : PRINT : PRINT

COLOR 7, 0                            'WHITE/BLACK
LOCATE 5, 15
PRINT "SELECT OPERATING MODE"
PRINT
PRINT TAB(15); "  1 - ENTER 'TO' VALUES ONLY"
PRINT
PRINT TAB(15); "  2 - SELECT UNUSED 'FROM' AND 'TO' VALUES"
PRINT
PRINT TAB(15); "  3 - CHANGE EXISTING 'FROM' AND 'TO' VALUES"
PRINT
PRINT TAB(15); "  4 - AUTOMATICALLY CHANGE 'FR0M' AND 'TO' VALUES"
PRINT
PRINT TAB(15); "  5 - PRINT ROTOR"
PRINT
PRINT TAB(15); "  6 - SAVE OR READ ROTOR TO/FROM FLOPPY DISK"
PRINT
INPUT ; "                ", M4
PRINT
IF M4 > 6 OR M4 < 1 GOTO START

ON M4 GOTO TABA, TAB50, TAB30, TAB75A, TAB60, TABX

TABA:

TAB0:                                 'START OF 1ST PASS

GOSUB TAB1                            'ENTER A 'TO' VALUE (ROTOR REAR)

GOSUB TAB2                            'LOCATE 1ST EMPTY 'TO' CELL

GOSUB TAB3                            'DETERMINE & TEST INTERVAL

GOSUB TAB6                            'TEST FOR COMPLETION

IF Q = 2 GOTO TAB0                    'FOR KEYBOARD INPUT

GOSUB TAB4                            'PRINT CURRENT RESULTS

GOTO TAB0


TAB1: '----------Mode 1-------------- ENTER THE 'TO' VALUE (ROTOR REAR)
TAB1A:
  M = 1

SKIP9:

  IF Q = 1 OR Q = 2 GOTO SWITCH
  CLS
  LOCATE 10, 24
  PRINT "SELECT INPUT METHOD"
  LOCATE 12, 22
  PRINT "  1 - AUTOMATIC FROM DATA STATEMENTS"
  LOCATE 14, 22
  PRINT "  2 - MANUAL THRU KEYBOARD"
  LOCATE 16, 24
  INPUT "", Q
  IF Q > 2 GOTO SKIP9
SWITCH:

ON Q GOTO INPUT1, INPUT2

INPUT1:

  IF DF <> 0 THEN GOTO DATA0          'SKIP DATA STATEMENT SELECTION
  CLS
 
  LOCATE 7, 25
  PRINT "SELECT DEMO No. (1 TO 3)"
  PRINT
  PRINT "  1 - PARTIAL WIRING AFTER TRYING PREVIOUSLY REJECTED CONNECTIONS"
  PRINT
  PRINT "  2 - PARTIAL WIRING WITHOUT TRYING PREVIOUSLY REJECTED CONNECTIONS"
  PRINT
  PRINT "  3 - COMPLETE WIRING (99 POSITIONS)"
  PRINT
  INPUT "  ", DF
  IF DF > 3 THEN
     DF = 0
     GOTO INPUT1
     END IF

  SELECT CASE DF
    CASE 1
      RESTORE DATA1
    CASE 2
      RESTORE DATA2
    CASE 3
      RESTORE DATA3
    CASE ELSE
      GOTO INPUT1
  END SELECT

DATA0:

  LOCATE 24, 1
  READ T
  IF T = 300 THEN
     GOTO TAB50                       'GOTO MODE 2
     END IF
  IF T = 400 GOTO SKIP10              'BLANK IF DATA STATEMENT
  IF T = 9999 GOTO TAB50
  GOTO TEST1

INPUT2:
  GOSUB TAB4
  LOCATE 23, 1
  PRINT STRING$(80, 32); ""
  LOCATE 24, 1
  PRINT "Mode "; M; " : ";
  INPUT ; "ENTER 'TO' VALUE (9999 for new mode)  ", T
  IF T = 9999 GOTO START
  IF T > H THEN
     LOCATE 23, 1
     COLOR 14, 0                      'YELLOW/BLACK
     PRINT "         ENTRY TOO LARGE. RE-ENTER NUMBER LESS THAN "; H
     BEEP: FOR Z9 = 1 TO Z8: NEXT Z9: BEEP
     FOR X8 = 1 TO 300000: NEXT X8
     COLOR 7, 0                       'WHITE/BLACK
     GOTO INPUT2
     END IF

TEST1:

  IF T < 1 GOTO START
  IF U(T) <> 0 THEN                   'TEST FOR DUPLICATE INPUT
    FOR X7 = 1 TO 2
      BEEP: FOR Z9 = 1 TO Z8: NEXT Z9: BEEP
      FOR X8 = 1 TO 5000
        LOCATE 23, 1
        COLOR 14, 0
        PRINT TAB(12); "CANNOT USE THIS ENTRY - (ALREADY USED).  SELECT ANOTHER"
      NEXT X8
      LOCATE 23, 1
      PRINT STRING$(80, " ")
      FOR X6 = 1 TO 50000: NEXT X6
    NEXT X7
    COLOR 7, 0                        'WHITE/BLACK
    GOTO TAB1A
  ELSE                                'U(T) IS EMPTY (0)
     U(T) = T
     END IF
SKIP10:
  RETURN                              'TO GOSUB TAB2


TAB2: '------------------------------- LOCATE 1ST EMPTY 'TO' CELL (1ST PASS)

  C = C + 1
  
  FOR X = C TO H
      IF T(X) = 200 THEN EXIT FOR     'X IS THE EMPTY CELL NUMBER
  NEXT X
     C = X

  RETURN                              'TO GOSUB TAB3

 
TAB3:  '------------------------------ CHECK INTERVAL BETWEEN 'FROM & 'TO'

  IF T = 400 GOTO SKIP11
  V = 0
  T2 = T
  IF T2 < F(X) THEN T2 = T2 + H
  I = ABS(T2 - F(X))                  'INTERVAL BETWEEN 'FROM' AND 'TO'

  A1 = 0                              'TEST IF INTERVAL VALUE DUPLICATED

  FOR A = 1 TO H
    A1 = A1 + 1
    IF I(A) = I THEN                  'DUPLICATE FOUND
       V = 1
       BEEP
       EXIT FOR
    END IF
  NEXT A

SKIP13:

  IF A1 = H THEN                      'H = INTERVAL VALUE NOT PRESENT IN I()
    I(X) = I                          'SAVE INTERVAL VALUE IN WORKING ARRAY
    T(X) = T                          'SAVE 'TO' VALUE (ROTOR REVERSE SIDE)
    A(I + 1) = I                      'SAVE INTERVAL VALUE IN CHECKING ARRAY
    IF I = 0 THEN A(1) = 0
  ELSE
    U(T) = 0                          'REMOVE PREVIOUSLY ASSIGNED 'T' VALUE
    T(X) = 200
    C = C - 1                         'CANCEL MOVE TO NEXT 'F' POSITION
  END IF

SKIP11:

  RETURN


TAB6:  '------------------------ TEST FOR COMPLETION DURING ORIGINAL CYCLE
  IF T = 400 GOTO SKIP12
  IF A1 < X THEN                      'INTERVAL POSITION ALREADY ASSIGNED
      Z = 1                           'FLAG FOR NEW CYCLE TO TAB0
      I(X) = 200
      T(X) = 200
      GOTO NOTDONE
  END IF
  IF K = 1 THEN GOTO NOTDONE
  T(X) = T
NOTDONE:
  L = 1                               'FLAG TO PREVENT DISPLAY REPEATS
SKIP12:

  RETURN


TAB4:   '----------------------------- PRINT CURRENT RESULTS
  
  COLOR 7, 0                          'WHITE/BLACK

  GOSUB TAB70                         'PRINT TOP-OF-SCREEN DATA

  LOCATE 2, 1
  FOR Y = 1 TO 5                      'HEADINGS
    PRINT T$;
  NEXT Y
  PRINT

  N1$ = "## "
  N2$ = "##  "
  N3$ = "\\ "
  N4$ = "\\  "

  LOCATE 3, 1
  FOR R = 1 TO 20
    K = -20
  FOR C1 = 1 TO 5
    COLOR 12, 0                       'RED / BLACK
    K = K + 20
    IF F(R + K) = H THEN
      PRINT USING N3$; "00";
      GOTO SKIP0
    END IF
    PRINT USING N1$; F(R + K);
SKIP0:
  COLOR 7, 0                          'WHITE/BLACK
  IF I(R + K) = H THEN
    PRINT USING N3$; "00";
    GOTO SKIP2
    END IF
   
  IF I(R + K) = 200 THEN GOTO SKIP1
  PRINT USING N1$; I(R + K);
  GOTO SKIP2

SKIP1:
  PRINT USING N3$; "";

SKIP2:
  IF T(R + K) = H THEN
    PRINT USING N3$; "00";
    GOTO SKIP4
    END IF

  IF T(R + K) = 200 THEN GOTO SKIP3
    PRINT USING N1$; T(R + K);
    GOTO SKIP4
   
SKIP3:
  PRINT USING N3$; "";

SKIP4:
  IF U(R + K) = 0 THEN GOTO SKIP5
  COLOR 14, 0                         'YELLOW/BLACK
  IF U(R + K) = H THEN
    PRINT USING N3$; "00";
    GOTO SKIP6
    END IF
     
  PRINT USING N1$; U(R + K);
  COLOR 7, 0                          'WHITE/BLACK
  GOTO SKIP6

SKIP5:
  PRINT USING N3$; "";

SKIP6:
  IF A(R + K) = H THEN
    PRINT USING N4$; "00";
    GOTO SKIP8
    END IF

  IF A(R + K) = 200 THEN GOTO SKIP7
  PRINT USING N2$; A(R + K);
  GOTO SKIP8

SKIP7:
  PRINT USING N4$; "";

SKIP8:
  NEXT C1
  PRINT
NEXT R

  J = 1                               'FLAG TO PREVENT DISPLAY REPEATS
 
RETURN


TAB30:   '--------Mode 3-------------- TRY ALTERNATE ASSIGNMENTS
  M = 3
  GOSUB TAB4
  COLOR 14, 0                         'YELLOW/BLACK

TAB32:
  LOCATE 24, 1
  PRINT TAB(73); "     ";

  LOCATE 24, 1
  PRINT "Mode "; M; ": ";
  INPUT ; "1 - ENTER THE 'FROM' POSITION TO EMPTY (9999 for new mode) : ", F
  IF F > H GOTO START
  IF F < 1 GOTO TAB32
  IF T(F) = 200 THEN
    LOCATE 24, 1
    PRINT "'From' position is already blank. Try another 'from' position"
    GOTO TAB32
    END IF

                                      'SAVE VALUES FOR POSSIBLE RESTORATION
  
  W2 = I(F)                           'STORE VALUES IN HOLDING VARIABLES
  W1 = T(F)
  W3 = U(T(F))
  W4 = A(I(F) + 1)
   
            
  U(T(F)) = 0                         'REMOVE VALUES
  A(I(F) + 1) = 200
  T(F) = 200
  I(F) = 200
   
  GOSUB TAB4                          'PRINT RESULT FOR INSPECTION
  COLOR 14, 0                         'YELLOW/BLACK

RETRY1:
  LOCATE 24, 1
  PRINT TAB(73); "     ";

  LOCATE 24, 1
  PRINT "Mode "; M; ": ";
  INPUT ; "2 - ENTER AN EMPTY -(F)- 'FROM' VALUE  (0=GO BACK TO STEP 1) ", X
  IF X > H GOTO RETRY1
  IF X = 0 THEN                       'RESTORE AND GO BACK TO STEP 1
    T(F) = W1
    I(F) = W2
    U(T(F)) = W3
    A(I(F) + 1) = W4
    GOTO TAB30
    END IF

  IF T(X) <> 200 GOTO RETRY1          'CHECK FOR EMPTY CELL

TAB31:
  GOSUB TAB4
  LOCATE 24, 1
  PRINT TAB(73); "     ";

  LOCATE 24, 1
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "Mode "; M; ": ";
  INPUT ; "3 - ENTER AN EMPTY 'TO' -(U)-  VALUE   (0=GO BACK TO STEP 2)  ", T
  LOCATE 23, 1
  PRINT STRING$(80, 32); ""
  IF F = X AND T = W1 GOTO TAB31      'PREVENTS MEANINGLESS HIT
  IF T > H GOTO TAB31
  IF T = 0 GOTO RETRY1
 
  IF U(T) <> 0 THEN                   'TEST FOR DUPLICATE INPUT
     PRINT
     BEEP: FOR Z9 = 1 TO Z8: NEXT Z9: BEEP
     COLOR 12, 0                      'RED/BLACK
     PRINT "   CANNOT USE THIS ENTRY - ALREADY USED"
     COLOR 7, 0                       'WHITE/BLACK
     GOTO TAB31                       'DUPLICATE FOUND - TRY ANOTHER
     END IF

  U(T) = T
  T(X) = T

  T2 = T
  IF T2 < F(X) THEN T2 = T2 + H
  I = ABS(T2 - F(X))                  'INTERVAL BETWEEN 'FROM' AND 'TO'

  A1 = 0                              'TEST IF INTERVAL VALUE DUPLICATED
  
  FOR A = 1 TO H
    A1 = A1 + 1
    IF I = 200 THEN GOTO BYPASS1
    IF I(A) = I THEN EXIT FOR         'INTERVAL PRESENT
BYPASS1:
  NEXT A

BYPASS2:

  IF A1 = H THEN                      'H = INTERVAL VALUE NOT PRESENT
    I(X) = I                          'SAVE INTERVAL VALUE IN WORKING ARRAY
    T(X) = T                          'SAVE 'TO' VALUE
    A(I + 1) = I                      'SAVE INTERVAL VALUE IN CHECKING ARRAY
    IF I = 0 THEN A(1) = 0
    BEEP
  ELSE                                'INTERVAL DUPLICATED
    U(T) = 0                          'RESTORE ORIGINAL VALUES
    T(X) = 200
    GOTO TAB31
    
RETRY3:
    T(F) = W1
    I(F) = W2
    U(W1) = W3
    A(W2 + 1) = W4
    BEEP
    END IF

GOTO TAB30


TAB50:  '-----Mode 2------------------ SELECT UNUSED 'FROM' & 'TO' VALUES

  M = 2
  X = 0: T = 0: I = 0: A1 = 0

TAB50A:
  GOSUB TAB4
  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK

RETRY4:
  PRINT TAB(73); "     ";
  LOCATE 24, 1
  PRINT "Mode "; M; " : ";
  INPUT ; "1 - ENTER AN UNUSED -(F)- 'FROM' VALUE  (9999 for new mode) : ", X
  IF X > H GOTO START
  IF X < 1 GOTO START

RETRY2:
  GOSUB TAB70                         'PRINT TOP-OF-SCREEN
  LOCATE 24, 1
  PRINT TAB(73); "     ";             'BLANK LINE
  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK
  PRINT "Mode "; M; " : ";
  INPUT ; "2 - ENTER AN UNUSED -(U)- 'TO' VALUE   (0=Go back to Step 1)  ", T
  IF T < 1 THEN
    LOCATE 24, 1
    PRINT TAB(73); "     ";
    LOCATE 24, 1
    GOTO RETRY4
    END IF
  IF T > H GOTO RETRY2
  K = 1

  IF U(T) <> 0 THEN
    BEEP: FOR Z9 = 1 TO Z8: NEXT Z9: BEEP
    COLOR 14, 0                       'YELLOW/BLACK
    LOCATE 23, 1
    PRINT TAB(24); "SELECT ANOTHER ENTRY"
    FOR X8 = 1 TO 300000: NEXT X8
    LOCATE 23, 1
    PRINT STRING$(80, 32); ""
    GOTO RETRY2
  ELSE
    U(T) = T
    END IF

  GOSUB TAB3                          'CHECK INTERVAL
  IF V = 1 GOTO RETRY2
  GOTO TAB50A                         'REPEAT


TAB60:  '--------Mode 4--------------- PRINT ROTOR

  CLS
  LOCATE 12, 20

  INPUT "ENTER ROTOR NUMBER : ", R7$
 
  LPRINT CHR$(27); "W"; CHR$(1);      'DOUBLE WIDE

  LPRINT "Rotor "; R7$
  LPRINT

  LPRINT CHR$(27); "W"; CHR$(0);      'DOUBLE WIDE CANCEL

  E = 25
  D = -E
  FOR Y = 1 TO 4
    D = D + E

    LPRINT USING "\\:"; "F ";
    FOR X = 1 TO E
      IF F(X + D) = H THEN
        LPRINT USING " \\"; "00";
        GOTO PASS1
        END IF
      LPRINT USING " ##"; F(X + D);

PASS1:
    NEXT X
    LPRINT : 'LPRINT

    LPRINT USING "\\:"; "I ";
    FOR X = 1 TO E
      IF I(X + D) = 200 THEN
        LPRINT USING " \\"; "";
        GOTO PASS2
      END IF
      LPRINT USING " ##"; I(X + D);

PASS2:
    NEXT X
    LPRINT : 'LPRINT

    LPRINT USING "\\:"; "T ";
    FOR X = 1 TO E

      IF T(X + D) = 200 THEN
         LPRINT USING " \\"; "";
         GOTO PASS3
      END IF

      IF T(X + D) = H THEN
        LPRINT USING " \\"; "00";
        GOTO PASS3
      END IF

      LPRINT USING " ##"; T(X + D);

PASS3:
    NEXT X
    LPRINT

    FOR X = 1 TO E + 1
      LPRINT USING "\ \"; "---";
    NEXT X
    LPRINT : 'LPRINT

    LPRINT USING "\\:"; "U ";
    FOR X = 1 TO E

      IF U(X + D) = 0 THEN
        LPRINT USING " \\"; "";
        GOTO PASS4
      END IF

      IF U(X + D) = H THEN
        LPRINT USING " \\"; "00";
        GOTO PASS4
      END IF

      LPRINT USING " ##"; U(X + D);

PASS4:
    NEXT X
    LPRINT

    LPRINT USING "\\:"; "A ";
    FOR X = 1 TO E
      IF A(X + D) = 200 THEN
        LPRINT USING " \\"; "";
        GOTO PASS5
      END IF
      LPRINT USING " ##"; A(X + D);

PASS5:
    NEXT X
    LPRINT : LPRINT : LPRINT : LPRINT
      
  NEXT Y

  GOTO START

TAB70: '------------------------------ PRINT TOP-OF-SCREEN DATA

  LOCATE 1, 1
  PRINT USING "M## - FROM POSITION :###  "; M; X;
  PRINT USING " TO POSITION :###  "; T;
  PRINT USING " INTERVAL : ## "; I;
  IF A1 < H THEN
    COLOR 12, 0                       'RED/BLACK
    PRINT USING " INTERVAL AT : ### "; A1;
  ELSE
    COLOR 10, 0                       'GREEN/BLACK
    PRINT "     INTERVAL O.K.";
  END IF
  COLOR 7, 0                          'WHITE/BLACK
  'SLEEP

RETURN                                'TO TAB4
                                     

TAB75A: '-------------Mode 5---------- AUTOMATICALLY TRY ALTERNATE ASSIGNMENTS

  T1 = TIMER                          'TIMING START

STEP0A:

  GOSUB TAB4
  'SLEEP
  Y5 = 0
  
STEP1A: '---------------------------- 'SELECT -F- POSITION TO BLANK

  M = 3
  FOR Z5 = 1 TO H                     'CLEAR HOLDING VARIABLES
    IF T(Z5) = W1 THEN W1 = 200
    IF I(Z5) = W2 THEN W2 = 200
    IF U(Z5) = W3 THEN W3 = 0
    IF A(Z5) = W4 THEN W4 = 200
  NEXT Z5

  Y5 = 0
  F = F + 1                           'SELECT POSITION
  IF F > H THEN
     F = 1
     M1 = M1 + 1                      'COMPLETE CYCLE COUNTER
     END IF
  IF T(F) = 200 GOTO STEP1A           'SKIP IF POSITION IS BLANK
   
  
                                      'SAVE VALUES FOR POSSIBLE RESTORATION

  W2 = I(F)                           'STORE VALUES IN HOLDING VARIABLES
  W1 = T(F)
  W3 = U(T(F))
  W4 = A(I(F) + 1)
  W3A = T(F)
  W4A = I(F)
  
  U(T(F)) = 0                         'REMOVE VALUES (BLANK THE POSITION)
  A(I(F) + 1) = 200
  T(F) = 200
  I(F) = 200

STEP2A:   '--------------------------- SELECT A BLANK -F- POSITION TO TEST

  FOR G = 1 TO H                      'FIND A BLANK -F- POSITION TO TEST
  IF T(G) = 200 THEN GOSUB STEP3A     'A BLANK POSITION
SKIP15:
  NEXT G
 
  GOTO STEP1A

STEP3A: '----------------------------- SELECT A -TO- POSITION TO TEST

  X = G

  FOR Y5 = 1 TO H
    IF Y5 = W1 AND G = F THEN GOTO SKIP14
    IF U(Y5) = 0 THEN GOSUB STEP4A    'BLANK -TO- POSITION NUMBER
    IF A1 = H THEN EXIT FOR
SKIP14:
  NEXT Y5
  A1 = 0
  RETURN                              'TO G INCREMENTING (STEP 1)

STEP4A: '----------------------------- TEST INTERVAL

  T = Y5                              'THE -TO- POSITION TO TEST (IS BLANK)
 
  T2 = T
  IF T2 < F(X) THEN T2 = T2 + H
  I = ABS(T2 - F(X))                  'INTERVAL BETWEEN 'FROM' AND 'TO'
  
  A1 = 0                              'TEST IF INTERVAL VALUE DUPLICATED
  IF I = I(H) THEN GOTO BYPASS5
  
  FOR A = 1 TO H
    A1 = A1 + 1
    IF I(A) = I THEN EXIT FOR         'INTERVAL PRESENT
  NEXT A

BYPASS5:

  IF A1 = H THEN                      'H = INTERVAL VALUE NOT PRESENT
    U(T) = T                          'SAVE 'TO' VALUE IN CHECKING ARRAY
    I(X) = I                          'SAVE INTERVAL VALUE IN ROTOR
    T(X) = T                          'SAVE 'TO' VALUE IN ROTOR
    A(I + 1) = I                      'SAVE INTERVAL VALUE IN CHECKING ARRAY
    IF I = 0 THEN A(1) = 0
   
    GOSUB TAB97                       'MODE 2 PROCESSING

    M = 3
    END IF

  GOSUB TAB4                          'DISPLAY ROTOR
  'SLEEP
  M6 = 0: M7 = 0: M8 = O: M9 = 0      'COUNT T(), U(), I() & A()
  FOR M5 = 1 TO H
    IF T(M5) = 200 THEN               'DETERMINE HOW MANY T() CELLS ARE EMPTY
       M6 = M6 + 1
       END IF
    IF U(M5) = 0 THEN                 'DETERMINE HOW MANY U() CELLS ARE EMPTY
       M7 = M7 + 1
       END IF
    IF I(M5) = 200 THEN
       M8 = M8 + 1
       END IF
    IF A(M5) = 200 THEN
       M9 = M9 + 1
       END IF
  NEXT M5

LOCATE 23, 1
L$ = "Cycle ### :  ## T   ## U   ## I   ## A       F1 = ###     F2 = ###     T = ###"
PRINT USING L$; M1 + 1; H - M6; H - M7; H - M8; H - M9; F; X; T

IF (H - M6) <> (H - M7) THEN
   LOCATE 24, 1
   PRINT "'T' DOES NOT EQUAL 'U'"
   SLEEP
   END IF

  C5 = C5 + 1
  LOCATE 24, 68
  PRINT USING "Try ###,###"; C5;
  LOCATE 24, 1
  COLOR 7, 0                          'WHITE/BLACK
 
  IF H - M7 = H - 1 AND H - M6 = H - 1 THEN        'END OF RUN
     GOSUB TAB90
     
     U(J7) = 0

     X$ = "Unused positions :   (From = ###)    (To = ###)    (Interval = ##)"
     PRINT USING X$; J9; J7; J8 - 1

     GOSUB TAB95                      'TIME OF RUN

     INPUT "   ENTER 9999 TO PRINT ROTOR ", O
     IF O = 9999 GOTO TAB60           'PRINT ROTOR
     END IF

RETURN                                'TO NEXT T POSITION TO TEST


TAB90: '------------------------------ LOCATE EMPTY ARRAY CELLS

   FOR J7 = 1 TO H                    'LOCATE UNUSED 'TO' POSITION
     IF U(J7) = 0 THEN
     EXIT FOR
     END IF
   NEXT J7

  
   FOR J8 = 1 TO H                    'LOCATE UNUSED INTERVAL
     IF A(J8) = 200 THEN
     EXIT FOR
     END IF
   NEXT J8

   FOR J9 = 1 TO H                    'LOCATE UNUSED 'FROM' POSITION
     IF T(J9) = 200 THEN
     EXIT FOR
     END IF
   NEXT J9

RETURN

TAB95:  '----------------------------- DETERMINATION OF TIME OF RUN

  T3 = TIMER                          'END TIME
  T5 = (T3 - T1) / 3600               'HOURS
  T6 = (T5 - FIX(T5)) * 60            'MINUTES
  T7 = (T6 - FIX(T6)) * 60            'SECONDS
  PRINT "Elapsed Time : ";
  PRINT USING "## hours ## minutes ## seconds"; FIX(T5); FIX(T6); CINT(T7);

RETURN


TAB97:  '-----Mode 2---(automatically)--- SELECT UNUSED 'FROM' & 'TO' VALUES

  M = 2
 
GOSUB TAB4
  'SLEEP
  X = 0: T = 0: I = 0: A1 = 0
  
  FOR G5 = 1 TO H                     'FIND BLANK -F- FROM POSITION
     IF T(G5) = 200 THEN GOSUB TEST4
     NEXT G5
RETURN                                'TO MODE 3 PROCESSING

TEST4:

  GOSUB TAB70                         'PRINT TOP-OF-SCREEN DATA
  'SLEEP
  X = G5
  LOCATE 24, 1
 
  FOR G6 = 1 TO H                     'FIND A BLANK -U- 'TO' POSITION
     IF G6 = W1 THEN GOTO SKIP16      'SKIP TEMPORARILY BLANKED POSITION
     IF U(G6) = 0 THEN GOSUB TEST7
SKIP16:
  NEXT G6
  IF A1 = H THEN G5 = H               'TO START NEW SEARCH AT 1 IF O.K.
RETURN

TEST7:                                'TEST INTERVAL
  T = G6

  T2 = T                              'COMPUTE INTERVAL
  IF T2 < F(X) THEN T2 = T2 + H
  I = ABS(T2 - F(X))                  'INTERVAL BETWEEN 'FROM' AND 'TO'

  A1 = 0                              'TEST IF INTERVAL VALUE DUPLICATED
  IF I = I(H) THEN GOTO BYPASS5A
  
  FOR A = 1 TO H
    A1 = A1 + 1
    IF I(A) = I THEN                  'DUPLICATE FOUND
       EXIT FOR
       END IF
   NEXT A

BYPASS5A:

  IF A1 = H THEN                      'H = INTERVAL VALUE NOT PRESENT IN I()
    I(X) = I                          'SAVE INTERVAL VALUE IN WORKING ARRAY
    T(X) = T                          'SAVE 'TO' VALUE (ROTOR REVERSE SIDE)
    U(T) = T
    A(I + 1) = I                      'SAVE INTERVAL VALUE IN CHECKING ARRAY
    IF I = 0 THEN A(1) = 0
    G6 = H
    GOSUB TAB4
    'SLEEP
  ELSE                                '<H = INTERVAL VALUE PRESENT
    C = C - 1                         'CANCEL MOVE TO NEXT 'F' POSITION
    RETURN                            'TO G6
  END IF

RETURN                                'TO G6


TABX:   '----------------------------- ROUTINE TO MAKE ROTOR DISK FILES

  CLS
  PRINT "DO YOU WANT TO : "
  PRINT
  PRINT "  1 - CREATE A ROTOR FILE ON THE DISK"
  PRINT
  PRINT "  2 - READ A ROTOR FILE FROM THE DISK"
  PRINT
  INPUT Q7
  ON Q7 GOTO TAB1Y, TAB2Y
  GOTO TABX


TAB1Y:

  CLS
  LOCATE 10, 10
  PRINT "VACANT 'FROM' POSITION IS "; J9
  LOCATE 12, 10
  PRINT "VACANT 'TO'   POSITION IS "; J7
  LOCATE 14, 10
  INPUT ; "ENTER THE VACANT 'FROM' POSITION (F) : ", N5      '  J9
  LOCATE 16, 10
  INPUT ; "ENTER THE VACANT 'TO' POSITION   (U) : ", T(N5)   '  J7

  CLS
  LOCATE 10, 10
  INPUT ; "INSERT ROTOR DISK INTO DRIVE B THEN PRESS 'ENTER'", Q
  CLS

  R$ = STRING$(200, "0")

  Y = 1
  FOR B = 1 TO 100
     MID$(R$, Y, 2) = RIGHT$(STR$(T(B)), 2)
     Y = Y + 2
  NEXT B
      

  PRINT
  PRINT "ROTOR FILLED"
  PRINT

'--------------------------------------------------------
REM - ROUTINE TO CREATE RANDOM-ACCESS DISK FILE OF ROTORS
'--------------------------------------------------------

  TYPE ROTORSET
       ROTOR AS STRING * 200
  END TYPE

  DIM ROTORS AS ROTORSET

  OPEN "B:ROTORS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200
  PRINT "LAST ROTOR ON FILE IS NUMBER : "; NUM.RECS
  PRINT
  INPUT "ENTER NEXT BEGINNING ROTOR DISK NUMBER  ", ROTORNO
  PRINT

  ROTORS.ROTOR = R$
  PUT #1, ROTORNO, ROTORS
  ROTORNO = ROTORNO + 1

  CLOSE #1

  PRINT "1 ROTOR DISK FILE ADDED"
  PRINT



TAB2Y:  '----------------------------- ROUTINE TO READ ROTORS FROM FILE
  CLS
  OPEN "B:ROTORS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200

  DO
    CLS
    PRINT
    INPUT ; "ENTER ROTOR NUMBER TO SEE CONTENTS :  ", ROTORNUM
'   IF ((ROTORNUM <= NUM.RECS) AND (ROTORNUM > 0)) THEN GET #1, ROTORNUM, ROTORS
    PRINT
    GET #1, ROTORNUM, ROTORS
    CLS
    PRINT TAB(32); "REGULAR ROTOR No. "; ROTORNUM
    PRINT
    Y3 = 0
    U5 = 1
    FOR X9 = 1 TO 4
      PRINT USING "\   \"; "From ";
      FOR Y7 = 1 TO 25
        PRINT USING "###"; Y3 + Y7;
      NEXT Y7
      PRINT
      Y3 = Y3 + 25

      GOSUB TABZ
      PRINT USING "\   \"; "To   ";
      FOR U = 1 TO 25
        PRINT USING " \\"; MID$(ROTORS.ROTOR, U5, 2);
        U5 = U5 + 2
      NEXT U
    PRINT : PRINT : PRINT
    NEXT X9

    PRINT
    INPUT "DO YOU WANT ANOTHER ROTOR (Y or N)  ", ANS$
  LOOP UNTIL (ANS$ = "N")


  GOTO START                          'TO MAIN MENU

TABZ:
  PRINT USING "\   \"; "     ";
  COLOR 14, 0                         'YELLOW/BLACK
  FOR Z = 1 TO 25
  PRINT USING " \\"; "--";
  NEXT Z
  COLOR 7, 0                          'WHITE/BLACK
  PRINT
  RETURN



