REM CRYPTO30 - RANDOM CHARACTER SET GENERATOR                    (31 AUG 95)

'              This program creates randomized Character Sets for use in the
'              Enigma95 Cipher Machine.  It creates, prints and/or saves to
'              disk the sets into a file titled CHARS.DAT.
'----------------------------------------------------------------------------

  DIM N$(100)                           'BASE CONTROL

  RANDOMIZE TIMER

  CLS

START1:                               'INITIAL STARTING POINT
  CLS
  C$ = STRING$(100, " ")              'SET VARIABLE LENGTH & CLEAR
                                                     
  D1$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 .,:;'=!@#$%&*"   '1/2 CHAR SET
  D2$ = "abcdefghijklmnopqrstuvwxyz~~~~~~~~~~~_-+/?(){}<>[]"   '1/2 CHAR SET

  D$ = D1$ + D2$                      'WHOLE CHARACTER SET

  L1A$ = "01 02 03 04 05 06 07 08 09 10 "
  L1B$ = "11 12 13 14 15 16 17 18 19 20"
  L2A$ = "21 22 23 24 25 26 27 28 29 30 "
  L2B$ = "31 32 33 34 35 36 37 38 39 40"
  L3A$ = "41 42 43 44 45 46 47 48 49 50 "
  L3B$ = "51 52 53 54 55 56 57 58 59 60"
  L4A$ = "61 62 63 64 65 66 67 68 69 70 "
  L4B$ = "71 72 73 74 75 76 77 78 79 80"
  L5A$ = "81 82 83 84 85 86 87 88 89 90 "
  L5B$ = "91 92 93 94 95 96 97 98 99 00"
  L6A$ = "-- -- -- -- -- -- -- -- -- -- "
  L6B$ = "-- -- -- -- -- -- -- -- -- --"

  L1$ = L1A$ + L1B$                   'CONSOLIDATE THE ABOVE
  L2$ = L2A$ + L2B$
  L3$ = L3A$ + L3B$
  L4$ = L4A$ + L4B$
  L5$ = L5A$ + L5B$
  L6$ = L6A$ + L6B$

  M1A$ = "01  02  03  04  05  06  07  08  09  10  "
  M1B$ = "11  12  13  14  15  16  17  18  19  20"
  M2A$ = "21  22  23  24  25  26  27  28  29  30  "
  M2B$ = "31  32  33  34  35  36  37  38  39  40"
  M3A$ = "41  42  43  44  45  46  47  48  49  50  "
  M3B$ = "51  52  53  54  55  56  57  58  59  60"
  M4A$ = "61  62  63  64  65  66  67  68  69  70  "
  M4B$ = "71  72  73  74  75  76  77  78  79  80"
  M5A$ = "81  82  83  84  85  86  87  88  89  90  "
  M5B$ = "91  92  93  94  95  96  97  98  99  00"
  M6A$ = "--  --  --  --  --  --  --  --  --  --  "
  M6B$ = "--  --  --  --  --  --  --  --  --  --"

  M1$ = M1A$ + M1B$                   'CONSOLIDATE THE ABOVE
  M2$ = M2A$ + M2B$
  M3$ = M3A$ + M3B$
  M4$ = M4A$ + M4B$
  M5$ = M5A$ + M5B$
  M6$ = M6A$ + M6B$

  LPRINT CHR$(27); "@";               'INITIALIZE PRINTER
  WIDTH LPRINT 160                    'SET LINE WIDTH TO 160 COLUMNS
  LPRINT CHR$(27); "Q"; CHR$(162);    'SET RIGHT MARGIN TO 162 COLUMNS
  LPRINT CHR$(27); "k"; CHR$(1);      'SANS SERIF FONT
  LPRINT CHR$(27); "M";               'ELITE PRINT
  LPRINT CHR$(27); "E";               'EMPHASIZED (BOLD) PRINTING

START1A:

  P$ = " "
  CLS
  LOCATE 4, 14
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "WELCOME TO CRYPTO30 - RANDOM CHARACTER SETS GENERATOR"
  LOCATE 6, 30
  COLOR 27, 0
  PRINT "INSERT TABLES DISK"

  LOCATE 22, 30
  COLOR 12, 0                         'RED/BLACK
  PRINT "Clarence E. Tyner Jr."
  LOCATE 23, 15
  PRINT "Copyrighted 1995 - All Rights Reserved Worldwide."
  COLOR 7, 0                          'WHITE/BLACK



  LOCATE 9, 28
  PRINT "   SELECT OPTION"
  LOCATE 11, 18
  PRINT "   1 - CREATE RANDOM CHARACTER SET"
  LOCATE 13, 18
  PRINT "   2 - RETRIEVE RANDOM CHARACTER SET"
  LOCATE 15, 18
  PRINT "   3 - ANALYZE CHARACTER SETS FOR COINCIDENCE"
  LOCATE 17, 18
  INPUT "   ", S

  ON S GOTO START2, TAB2Y, TAB10
  GOTO START1A

START2:                               'SUBSEQUENT STARTING POINT

  IF E$ = "1" THEN
     D$ = C$
     C$ = STRING$(100, " ")           'SET VARIABLE LENGTH & CLEAR
  ELSE
     E$ = "1"
  END IF

  B = 0
  FOR X = 1 TO 100: N$(X) = " ": NEXT X

START3:

  A = RND * 100
  A = INT(A)
  IF A = 0 THEN A = 100               'PREVENT A ZERO VALUE
  IF A < 1 OR A > 100 GOTO START3     'SELECT ONLY BETWEEN 1 AND 100
  IF N$(A) <> "`" THEN                'CHECK FOR DUPLICATES
     N$(A) = "`"
     B = B + 1
  ELSE
     GOTO START3
  END IF


  MID$(C$, B, 1) = MID$(D$, A, 1)

  IF B = 100 THEN
    CLS
    V = 0
    LOCATE 10, 25
    INPUT "ENTER CHARACTER SET No. "; N1
    CLS
    PRINT TAB(31); "CHARACTER SET  "; N1
    PRINT

    FOR Z = 1 TO 5

      PRINT USING "\   \"; "Posn ";
   
      SELECT CASE Z
        CASE 1
           PRINT TAB(10);
           GOSUB TAB1
        CASE 2
           PRINT TAB(10);
           GOSUB TAB2
        CASE 3
           PRINT TAB(10);
           GOSUB TAB3
        CASE 4
           PRINT TAB(10);
           GOSUB TAB4
        CASE 5
           PRINT TAB(10);
           GOSUB TAB5
      END SELECT

      GOSUB TAB6                      'DRAW A LINE ON SCREEN
      PRINT USING "\   \"; "Char ";
      PRINT TAB(10);

      FOR Y = 1 TO 20
        V = V + 1
        PRINT USING "\\ "; MID$(C$, V, 1);
      NEXT Y
      PRINT
      PRINT
    NEXT Z
  ELSE
    GOTO START3
  END IF

  PRINT TAB(10);
        
  INPUT "SELECT MODE : (1) NEXT SET, OR  (2) PRINT OR (3) SAVE TO DISK  ", Q
  ON Q GOTO START2, PRINTSET, TABX
  GOTO START2

TAB1:
  PRINT L1$                           '01 - 20
  RETURN
TAB2:              
  PRINT L2$                           '21 - 40
  RETURN
TAB3:
  PRINT L3$                           '41 - 60
  RETURN
TAB4:
  PRINT L4$                           '61 - 80
  RETURN
TAB5:
  PRINT L5$                           '81 - 100
  RETURN
 
TAB6:   '----------------------------- DRAW A LINE

  PRINT TAB(10);
  COLOR 14, 0
  PRINT L6$                           'COLUMN HEADINGS (--)
  COLOR 7, 0
  RETURN

TABX:   '----------------------------- ROUTINE TO MAKE CHARACTER SET FILES

  CLS
  PRINT "DO YOU WANT TO : "
  PRINT
  PRINT "  1 - SAVE THE CHARACTER SET TO DISK"
  PRINT
  PRINT "  2 - READ A CHARACTER SET FROM DISK"
  PRINT
  INPUT Q7
  ON Q7 GOTO TAB1Y, TAB2Y
  GOTO TABX


TAB1Y:  '----------------------------- CREATE A CHARACTER SET ON DISK

  CLS
  
  LOCATE 10, 10
  INPUT ; "INSERT CHARACTER SET DISK INTO DRIVE B THEN PRESS 'ENTER'", Q
  CLS

  R$ = STRING$(100, " ")

  Y = 1
  FOR B = 1 TO 100
     MID$(R$, B, 1) = MID$(C$, B, 1)
  NEXT B
     
  PRINT
  PRINT "CHARACTER SET CREATED"
  PRINT

'--------------------------------------------------------
REM - ROUTINE TO CREATE RANDOM-ACCESS DISK FILE OF ROTORS
'--------------------------------------------------------

  TYPE CHARSET
       CHAR AS STRING * 100
  END TYPE

  DIM CHARS AS CHARSET

  OPEN "B:CHARS.DAT" FOR RANDOM AS #1 LEN = 100

  NUM.RECS = LOF(1) / 100
  PRINT "LAST CHARACTER SET ON FILE IS NUMBER : "; NUM.RECS
  PRINT
  INPUT "ENTER NEXT CHARACTER SET NUMBER  ", CHARNO
  PRINT

  CHARS.CHAR = R$
  PUT #1, CHARNO, CHARS
  CHARNO = CHARNO + 1

  CLOSE #1

  PRINT "1 CHARACTER SET ADDED TO THE DISK FILE CHARS.DAT"
  PRINT



TAB2Y:  '----------------------------- READ CHARACTER SET FROM DISK
  CLS
  OPEN "B:CHARS.DAT" FOR RANDOM AS #1 LEN = 100

  NUM.RECS = LOF(1) / 100

  DO
    CLS
    PRINT
    INPUT "ENTER CHARACTER SET No. TO SEE CONTENTS :  ", CHARNUM
'   IF ((CHARNUM <= NUM.RECS) AND (CHARNUM > 0)) THEN GET #1, CHARNUM, CHARS
    CLS
    PRINT TAB(29); "CHARACTER SET No. "; CHARNUM
    GET #1, CHARNUM, CHARS
    PRINT

    Y3 = 0
    U5 = 1
    FOR X9 = 1 TO 5
      PRINT TAB(5);
      PRINT USING "\   \"; "Posn ";
      FOR Y7 = 1 TO 20
        PRINT USING "###"; Y3 + Y7;
      NEXT Y7
      PRINT
      Y3 = Y3 + 20
      PRINT TAB(5);
      GOSUB TABZ
      PRINT TAB(5);
      PRINT USING "\   \"; "Char ";
      FOR U = 1 TO 20
        PRINT USING " \\"; MID$(CHARS.CHAR, U5, 1);
        U5 = U5 + 1
      NEXT U
    PRINT : PRINT : 'PRINT
    NEXT X9

    PRINT
    INPUT ; "    DO YOU WANT TO SEE ANOTHER CHARACTER SET (Y or N)  ", ANS$
  LOOP UNTIL (ANS$ = "N")

  CLOSE #1
    LOCATE 24, 1
    COLOR 14, 0                       'YELLOW/BLACK
    INPUT "    DO YOU WANT TO PRINT THIS CHARACTER SET  (Y or N)    ", P$
    COLOR 7, 0                        'WHITE/BLACK
    IF P$ = "Y" THEN
       N1 = CHARNUM
       C$ = CHARS.CHAR
       GOTO PRINTSET
       END IF

  GOTO START1A                        'TO MAIN MENU


TABZ: '------------------------------- PRINT HEADINGS

  PRINT USING "\   \"; "     ";
  COLOR 14, 0                         'YELLOW/BLACK
  FOR Z = 1 TO 20
  PRINT USING " \\"; "--";
  NEXT Z
  COLOR 7, 0                          'WHITE/BLACK
  PRINT
  RETURN


PRINTSET:  '-------------------------- PRINT CHARACTER SET

  V = 0
  
  LPRINT CHR$(27); "W"; CHR$(1);      'DOUBLE WIDE
  LPRINT "           CHARACTER SET No. "; N1
  LPRINT CHR$(27); "W"; CHR$(0);      'DOUBLE WIDE CANCEL
  LPRINT

  FOR Z = 1 TO 5

    SELECT CASE Z
      CASE 1
         LPRINT TAB(5);
         GOSUB TAB1A
      CASE 2
         LPRINT TAB(5);
         GOSUB TAB2A
      CASE 3
         LPRINT TAB(5);
         GOSUB TAB3A
      CASE 4
         LPRINT TAB(5);
         GOSUB TAB4A
      CASE 5
         LPRINT TAB(5);
         GOSUB TAB5A
      END SELECT
         GOSUB TAB6A

  LPRINT TAB(5);
  FOR Y = 1 TO 20
    V = V + 1
    LPRINT USING "\\  "; MID$(C$, V, 1);
    NEXT Y
    LPRINT
    LPRINT
    LPRINT
  NEXT Z

  IF P$ = "Y" THEN GOTO START1A       'MAIN MENUE

  IF N1 MOD 2 = 0 THEN LPRINT CHR$(12) 'FORM FEED

GOTO TABX                             'MAKE ROTOR DISK FILE


TAB1A:
  LPRINT M1$                          '01 - 20
  RETURN
TAB2A:
  LPRINT M2$                          '21 - 40
  RETURN
TAB3A:
  LPRINT M3$                          '41 - 60
  RETURN
TAB4A:
  LPRINT M4$                          '61 - 80
  RETURN
TAB5A:
  LPRINT M5$                          '81 - 100
  RETURN
TAB6A:
  LPRINT TAB(5);
  LPRINT M6$                          'COLUMN HEADINGS
  RETURN

TAB10:  '----------------------------- ANALYZE SETS FOR COINCIDENCE

  CLS

  INPUT "ENTER MINIMUM NUMBER OF HITS TO DISPLAY ", E1
 
  OPEN "B:CHARS.DAT" FOR RANDOM AS #1 LEN = 100

  NUM.RECS = LOF(1) / 100

  FOR F1 = 1 TO 50
    CHARNUM = F1

    GET #1, CHARNUM, CHARS
    G4$ = CHARS.CHAR                  'BASE SET
    IF EOF(1) = -1 THEN
      PRINT "END OF FILE REACHED. PRESS <ENTER> TO RESTART"
      SLEEP
      CLOSE #1
      GOTO START1A
      END IF

     
    'FOR F2 = F1 + 1 TO 50
     FOR F2 = 1 TO 50
       IF F2 = F1 THEN GOTO TAB13
       CHARNUM = F2

TAB12:
      GET #1, CHARNUM, CHARS

      G5$ = CHARS.CHAR
   
      D = 0
      FOR X = 1 TO 100
        IF MID$(G4$, X, 1) = "~" OR MID$(G5$, X, 1) = "`" THEN GOTO TAB11
        IF MID$(G4$, X, 1) = MID$(G5$, X, 1) THEN
          D = D + 1
          IF D < E1 THEN GOTO TAB11

  COLOR 11, 0
  PRINT USING "Sets  ##  and  ##  : "; F1; F2;
  COLOR 10, 0
  PRINT USING "Match No. ##  is  \\  "; D; MID$(G5$, X, 1);
  COLOR 13, 0
  PRINT USING "At Position No. ###"; X
  COLOR 7, 0

        END IF
TAB11:
      NEXT X
   
TAB13:

  NEXT F2
  COLOR 14, 0                         'YELLOW/BLACK
  FOR J = 1 TO 62
    PRINT "-";
  NEXT J
  PRINT "press key"
  COLOR 7, 0                          'WHITE/BLACK
  SLEEP

  NEXT F1

