REM - ENIGMA95.BAS - ENIGMA95 CIPHER MACHINE                      (5 SEP 95)
REM $DYNAMIC

CLEAR
CLS
'              - 100-POSITION ROTORS. ALL ROTATE RANDOMLY AFTER EACH INPUT
'              - UTILIZES A FLOPPY DISK FOR :
'              -    100 ROTORS SETS (1 TO 12 CAN BE SELECTED IN ANY ORDER)
'              -    100 REVERSING ROTORS SETS
'              -    100 BASE CHARACTERS SETS (100 CHARACTERS PER SET)
'              -    100 SUPERENCIPHERMENT TABLES SETS (676 2-CHARACTER SETS)
'              - 100-POSITION PLUGBOARD
'              - ALPHANUMERIC CHARACTER/NUMBER/PUNCTUATION SETS
'              - ROTATES THE CHARACTER SET FOR ADDITIONAL SECURITY
'              - INPUT (ENCIPHERING OR DECIPHERING) WITHOUT <ENTER> KEY
'              - DOUBLE DIGIT NUMERIC CIPHER OUTPUT (00 to 99), OR
'              - DOUBLE ALPHA CHARACTER CIPHER OUTPUT
'              - ABILITY TO SUPER ENCIPHER/DECIPHER TO/FROM ALPHA FORMAT
'              - ENCIPHER / DECIPHER SWITCH
'              - SIMULTANEOUS INPUT & OUTPUT ON SCREEN AND PAPER
'              - CHECKSUMS TO VERIFY INTERNAL AND EXTERNAL SETTINGS
'              - PRODUCE ROW & COLUMN CHECK DIGITS FOR GARBLE CORRECTION
'              - HASH TOTAL OF NUMERIC OUTPUT (FOR ACCURACY CHECK)
'              - INPUT AND OUTPUT CHARACTER COUNTERS
'              - EASY CORRECTION OF INPUT ERRORS WITHIN EACH SCREEN
'              - CORRECT TEXT INPUT ERRORS WITHOUT RETYPING EVERYTHING
'              - PRODUCE INPUT/OUTPUT FREQUENCY ANALYSIS
'              - RANDOM NUMBER SELECTOR FOR SETTINGS
'              - POSSIBLE TO USE ROTORS IN 2 ORIENTATIONS (Fwd & Bkwd)
'              - MESSAGE CAN BE UP TO 1943 CHARACTERS (POSSIBLE TO INCREASE)
'              - REPEAT USE OF INTERNAL SETTINGS (FOR ADDITIONAL MESSAGES)

DIM A(12)                             'ROTORS DESIGNATOR ARRAY
DIM A$(12)                            'ROTORS ORIENTATION ARRAY
DIM B(100)                            'CLEARTEXT INPUT COUNTER
DIM B1(100)                           'CLEARTEXT BACKUP INPUT COUNTER
DIM C(100)                            'SUPER ENCIPHERMENT COL. COUNTER
DIM C1(100)                           'SUPER ENCIPHERMENT COUNTER HOLDER
DIM C4(27)                            'COLUMNS TALLY - FOR GARBLES CHECK
DIM C5(27)                            'COLUMNS TALLY - BACKUP
DIM C$(100)                           'CODE NUMBER ARRAY
DIM D(100)                            'CODE OUTPUT COUNTER
DIM D1(100)                           'CODE BACKUP OUTPUT COUNTER
DIM E1(100)                           'PLUGBOARD INPUT EDITOR
DIM F$(100, 8)                        'ALPHA SUPERENCIPHERING ARRAY
DIM G(26, 26)                         'SUPERENCIPHERMENT OUTPUT ANALYSIS
DIM G5(26, 26)                        'SUPERENCIPHERMENT OUTPUT ANALYSIS
DIM H(26)                             'SUPERENCIPHERMENT COLUMN COUNTER
DIM I3(100)                           'INPUT COUNTER
DIM O(100)                            'OUTPUT COUNTER
DIM P(24)                             'PRIME NUMBERS
DIM PB$(51)                           'PLUGBOARD CONNECTIONS
DIM R4(100)                           'ROWS TALLY - FOR GARBLES CHECK
DIM R5(100)                           'ROWS TALLY - BACKUP
DIM RB$(12)                           'BOTTOM OF SCREEN ROTOR DISPLAY
DIM S(13)                             'ROTOR ROTATION VALUE CHECK
DIM T(13)                             'INITIAL ROTOR SETTINGS
'--------------------far heap memory----------------------------------
DM1% = 1
DM12% = 12
DM26% = 26

DIM E10(DM1%) AS STRING * 80          'INPUT POSITION NUMBERS
DIM E20(DM1%) AS STRING * 80
DIM E30(DM1%) AS STRING * 80
DIM E40(DM1%) AS STRING * 80
DIM E50(DM1%) AS STRING * 80
DIM E60(DM1%) AS STRING * 80

DIM I(DM1%) AS STRING * 324           'SCREENFUL OF DATA - CIPHER
DIM I2(DM1%) AS STRING * 3888         '12 SCREENS ACCUMULATOR (Input 1944)
DIM I4(DM12%) AS STRING * 324         'OUTPUT HOLDING ARRAY
DIM J(DM26%, DM26%) AS STRING * 2     'ALPHA SUPER DECIPHERING ARRAY
DIM K(DM1%) AS STRING * 324           'SCREENFUL OF DATA - CLEARTEXT
DIM K2(DM1%) AS STRING * 3888         '12 SCREENS ACCUMULATOR (Input 1944)
DIM N(DM1%) AS STRING * 1600          'DIMENSION DISK ENCIPHER TABLE 1
DIM P0(DM12%) AS STRING * 200         'POSITION FACES OF ROTORS
DIM R(DM12%) AS STRING * 200          'ROTOR SET SELECTED
DIM R1(DM12%) AS STRING * 200         'ROTOR RECOVERY ARRAY
DIM R1A(DM12%) AS STRING * 200        'ROTOR RECOVERY ARRAY

I(1) = STRING$(324, "  ")             'TEMPORARY TEXT STORAGE
K(1) = STRING$(324, "  ")             'TEMPORARY TEXT STORAGE

'--------------------------------------------------------------------------

MAXMSG = 1943                         'MAXIMUM CHARACTERS PER MESSAGE
                                      '(12 SCREENS @ 162, LESS 1)

B$ = "01020304050607080910111213141516171819202122232425"
C$ = "26272829303132333435363738394041424344454647484950"
D$ = "51525354555657585960616263646566676869707172737475"
E$ = "76777879808182838485868788899091929394959697989900"
I$ = "14203802011205677211212530554381194890876651936296"

P0$ = B$ + C$ + D$ + E$               'MASTER ROTOR FRONT
PR$ = P0$                             'FRONT OF REVERSING ROTOR
CC$ = P0$                             'RANDOM STARTING POSITION SELECTOR
B$ = "": C$ = "": D$ = "": E$ = ""
Z1$ = P0$                             'PART 1 OF PLUGBOARD
Z2$ = P0$                             'PART 2 OF PLUGBOARD

FOR E = 1 TO 51: PB$(E) = "    ": NEXT E  'INITIALIZE PLUGBOARD
B4$ = "                          "    'MESSAGE BLANKER
T10$ = TIME$                          'TIME OF MESSAGE
D10$ = DATE$                          'DATE OF MESSAGE

D11$ = MID$(D10$, 1, 2) + " " + MID$(D10$, 4, 2) + " " + MID$(D10$, 9, 2)
T11$ = MID$(T10$, 1, 2) + " " + MID$(T10$, 4, 2) + " " + MID$(T10$, 7, 2)
F = FRE("")

TAB01:  '----------------------------- START OF PROGRAM

  CLS
  LOCATE 4, 21
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "Welcome to the ENIGMA-95 Cipher Machine"
  COLOR 7, 0                          'WHITE/BLACK

  COLOR 12, 0                         'RED/BLACK
  LOCATE 20, 5
  PRINT TAB(29); "By  Clarence E. Tyner Jr."
  LOCATE 21, 5
  PRINT TAB(18); "Copyright 1995 - All Rights Reserved Worldwide"
  COLOR 7, 0
  LOCATE 10, 18
  PRINT "DO YOU WANT TO (1) ENCIPHER OR (2) DECIPHER ?"
REPEAT01: Q$ = INKEY$: IF Q$ = "" THEN GOTO REPEAT01
  IF Q$ <> "1" AND Q$ <> "2" THEN GOTO TAB01
  CLS

  GOSUB TAB110                        'SELECT MESSAGE CONTROL RANDOM NUMBERS

  AA$ = "": BB$ = "": CC$ = "": DD$ = "": EE$ = ""

  CLS
  LOCATE 10, 18
  PRINT "INSERT ";
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "ROTORS DISK IN DRIVE ";
  COLOR 27, 0
  PRINT "B ";
  COLOR 7, 0                          'WHITE/BLACK
  BEEP: BEEP
  INPUT "THEN PRESS ENTER", O
  
  CLS

  M1$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 .,:;'=!@#$%&*"
  M2$ = "abcdefghijklmnopqrstuvwxyz_-+/?(){}<>[]~~~~~~~~~~~"
  M3$ = M1$ + M2$
  M1$ = "": M2$ = ""

  LPRINT CHR$(27); "@";               'INITIALIZE PRINTER
  LPRINT CHR$(27); "M";               'ELITE PRINT
  LPRINT CHR$(27); "k"; CHR$(1);      'SANS SERIF FONT
  LPRINT CHR$(27); "E";               'BOLD FONT
  WIDTH LPRINT 155                    'SET LINE WIDTH TO 155 COLUMNS
  LPRINT CHR$(27); "Q"; CHR$(162);    'SET RIGHT MARGIN TO 162 CHARACTERS
  LPRINT CHR$(27); "l"; CHR$(9);      'SET LEFT MARGIN TO 9 CHARACTERS

  Q = 1                               'FILL 2-DIGIT CODE NUMBER ARRAY
  FOR X = 1 TO 100
    C$(X) = MID$(P0$, Q, 2)
    Q = Q + 2
  NEXT X

  CLS

  GOSUB TAB59  '---------------------- SET PLUGBOARD

  CLS

REPEAT02:  '-------------------------- CREATE ROTORS

  LOCATE 11, 10
  INPUT "S.O.I. : ENTER NUMBER OF ROTORS TO BE USED (1 TO 12) :  ", N
  IF N > 12 THEN
    BEEP
    GOTO REPEAT02
  END IF
  IF N <= 0 THEN
    BEEP
    GOTO REPEAT02
  END IF
  PRINT

  CLS
  LOCATE 2, 18
  PRINT N; " ROTORS ARE TO BE SELECTED FROM THE S.O.I."
  CHECKSUM1 = CHECKSUM1 + N

  LOCATE 4, 8
  PRINT "Select Rotor (1 to 100) and Orientation (1 or 2) ";
  COLOR 14, 0                           'YELLOW/BLACK
  PRINT "IN THE SAME ENTRY"
  COLOR 7, 0                            'WHITE/BLACK
  PRINT
  PRINT TAB(13); "For example : < RO >  or  < RRO >  or  < RRRO >  <enter>"
  PRINT TAB(27); "< 71 >      < 232 >      < 1001 >"
  PRINT
  COLOR 14, 0                           'YELLOW/BLACK
  PRINT TAB(41); "ROTOR   ORIENTATION"
  LOCATE 24, 1
  PRINT "To correct a PRIOR entry, input ' * ' < enter >"

  FOR X = 1 TO N
REPEAT03:
  LOCATE 9 + X, 22
  COLOR 14, 0                         'YELLOW/BLACK
 
  PRINT ; "Position No. "; X;
  INPUT ; "    ", X$
  X10 = LEN(X$)

  IF X$ = "*" THEN                    'TO CORRECT PRIOR ENTRY
    X = X - 1
    PRINT STRING$(80, " ")
    GOTO REPEAT03
  END IF

  SELECT CASE X10
    CASE 2
      A(X) = VAL(MID$(X$, 1, 1))      'ROTORS 1 -9
    CASE 3
      A(X) = VAL(MID$(X$, 1, 2))      'ROTORS 10 - 99
    CASE 4
      A(X) = VAL(MID$(X$, 1, 3))      'ROTOR 100
  END SELECT

  A$(X) = RIGHT$(X$, 1)
  IF A(X) > 100 OR A(X) < 1 THEN
    BEEP
    LOCATE 11 + X, 1
    PRINT STRING$(80, " ")
    GOTO REPEAT03
  END IF

    FOR J5 = 1 TO X
      IF X = J5 THEN EXIT FOR
      IF A(X) = A(J5) THEN
        BEEP
        GOTO REPEAT03
      END IF
    NEXT J5

  LOCATE 10 + X, 55
  COLOR 14, 0                         'RED/BLACK
  IF A$(X) <> "1" AND A$(X) <> "2" THEN
    BEEP
    LOCATE 9 + X, 1
    PRINT STRING$(33, " ")
    GOTO REPEAT03
  END IF

  A(X) = VAL(MID$(X$, 1, X10 - 1))    'ROTOR No.
  A$(X) = RIGHT$(X$, 1)               'ORIENTATION
  LOCATE 10 + (X - 1), 1
  PRINT STRING$(80, " ")
  LOCATE 10 + (X - 1), 22
 
  IF A$(X) = "1" THEN
     COLOR 2, 0
     PRINT USING "Position No. ##     ###    \\- "; X; A(X); A$(X);
     PRINT "Forward"
  ELSE
     COLOR 12, 0
     PRINT USING "Position No. ##     ###    \\- "; X; A(X); A$(X);
     PRINT "Backward"
  END IF

  COLOR 14, 0
  LOCATE 10 + X, 1
  PRINT STRING$(80, " ")
  CHECKSUM1 = CHECKSUM1 + (A(X) * X) + (VAL(A$(X)) * X)
  NEXT X

  LOCATE 23, 1
  PRINT STRING$(80, " ")
  LOCATE 10 + X, 1

  COLOR 7, 0                          'WHITE/BLACK

TAB03:    ' -------------------------- START A NEW MESSAGE

  F1 = FRE("")
  IF F5 = 1 THEN                      'TO RESTART SCREEN (SET TO 1 IN TAB106)
    GOSUB TAB107                      'RESTORE ROTORS
    GOTO TAB09
  END IF

  G3 = 0
  G4 = 0
  K1 = 0
  X6 = 0
  X8 = 0
  X9 = 0
  R = 0

  FOR X = 1 TO 27: C4(X) = 0: NEXT X  'COLUMN TALLY

  FOR X = 1 TO 26
    FOR Y = 1 TO 26
      G(X, Y) = 0                     'INITIALIZE SE ANALYSIS COUNTER
    NEXT Y
  NEXT X

  W5 = 0                              'INITIALIZE PRINT SWITCH
  HC = 0                              'INITIALIZE HASH COUNT
  PR$ = P0$                           'FRONT OF REVERSING ROTOR

  FOR X = 0 TO 100                    'INITIALIZE
    R4(X) = 0                         'ROW TALLY
    O(X) = 0                          'INPUT/OUTPUT COUNTER
    C(X) = SE                         'SUPER ENCIPHERMENT COUNTER
  NEXT X

IF ANOTHER$ = "Y" THEN M = 0       'INITIALIZE SETTINGS PRINTING

  GOSUB TAB74                         'LOAD ROTORS FROM DISK

  FOR X = 1 TO N                      'PUT ROTORS IN CORRECT ORDER
                                      
    SELECT CASE X
      CASE 1
         R1(1) = R(X)
         P0(1) = P0$
         IF A$(X) = "2" THEN SWAP R1(1), P0(1)
        
      CASE 2
         R1(2) = R(X)
         P0(2) = P0$
         IF A$(X) = "2" THEN SWAP R1(2), P0(2)
        
      CASE 3
         R1(3) = R(X)
         P0(3) = P0$
         IF A$(X) = "2" THEN SWAP R1(3), P0(3)
        
      CASE 4
         R1(4) = R(X)
         P0(4) = P0$
         IF A$(X) = "2" THEN SWAP R1(4), P0(4)
        
      CASE 5
         R1(5) = R(X)
         P0(5) = P0$
         IF A$(X) = "2" THEN SWAP R1(5), P0(5)
        
      CASE 6
         R1(6) = R(X)
         P0(6) = P0$
         IF A$(X) = "2" THEN SWAP R1(6), P0(6)
        
      CASE 7
         R1(7) = R(X)
         P0(7) = P0$
         IF A$(X) = "2" THEN SWAP R1(7), P0(7)
        
      CASE 8
         R1(8) = R(X)
         P0(8) = P0$
         IF A$(X) = "2" THEN SWAP R1(8), P0(8)
        
      CASE 9
         R1(9) = R(X)
         P0(9) = P0$
         IF A$(X) = "2" THEN SWAP R1(9), P0(9)
        
      CASE 10
         R1(10) = R(X)
         P0(10) = P0$
         IF A$(X) = "2" THEN SWAP R1(10), P0(10)
        
      CASE 11
         R1(11) = R(X)
         P0(11) = P0$
         IF A$(X) = "2" THEN SWAP R1(11), P0(11)
        
      CASE 12
         R1(12) = R(X)
         P0(12) = P0$
         IF A$(X) = "2" THEN SWAP R1(12), P0(12)
        
    END SELECT

  NEXT X

  GOSUB TAB93                         'GET REVERSING ROTOR FROM DISK

  FOR C5 = 1 TO 200                   'FILL SPACES WITH ZEROS
    IF MID$(A6$, C5, 1) = " " THEN MID$(A6$, C5, 1) = "0"
  NEXT C5

  RR$ = A6$

  IF CORR$ = "Y" THEN GOTO TAB05      'CORRECTION OF CURRENT MESSAGE

  CLS
  LOCATE 1, 19
  PRINT "(See the current S.O.I for the values to use)"
  LOCATE 3, 20
  PRINT "SET ROTATIONAL SHIFT VALUES FOR EACH ROTOR"
  LOCATE 5, 20
  PRINT "POSITION USING THE FOLLOWING PRIME NUMBERS"
  LOCATE 8, 6
  PRINT "0,1,3,7,11,13,17,19,23,29,31,37,41,";
  PRINT "43,47,53,59,61,67,71,73,79,83,89,97"
  PRINT
 
  DATA 1,3,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97
  FOR PN = 1 TO 24
    READ P(PN)
  NEXT PN

  COLOR 14, 0                         'YELLOW/BLACK
  FOR X = 1 TO N
    SELECT CASE X
          CASE 1
REDO01:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 1   :  ", S1
            S(X) = S1
            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S1 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO01
            END IF
            S1A = 200 - (S1 * 2)

         CASE 2
REDO02:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 2   :  ", S2

            S(X) = S2                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S2 = S(J6) THEN
                BEEP
                GOTO REDO02:
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S2 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO02
            END IF
            S2A = 200 - (S2 * 2)

         CASE 3
REDO03:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 3   :  ", S3

            S(X) = S3                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S3 = S(J6) THEN
                BEEP
                GOTO REDO03
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S3 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO03
            END IF
            S3A = 200 - (S3 * 2)

         CASE 4
REDO04:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 4   :  ", S4

            S(X) = S4                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S4 = S(J6) THEN
                BEEP
                GOTO REDO04
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S4 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO04
            END IF
            S4A = 200 - (S4 * 2)

         CASE 5
REDO05:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 5   :  ", S5

            S(X) = S5                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S5 = S(J6) THEN
                BEEP
                GOTO REDO05
                EXIT FOR
              END IF
            NEXT J6
           
            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S5 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO05
            END IF
            S5A = 200 - (S5 * 2)

         CASE 6
REDO06:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 6   :  ", S6

            S(X) = S6                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S6 = S(J6) THEN
                BEEP
                GOTO REDO06
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S6 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO06
            END IF
              S6A = 200 - (S6 * 2)

         CASE 7
REDO07:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 7   :  ", S7

            S(X) = S7                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S7 = S(J6) THEN
                BEEP
                GOTO REDO07
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S7 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO07
            END IF
              S7A = 200 - (S7 * 2)

         CASE 8
REDO08:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 8   :  ", S8

            S(X) = S8                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S8 = S(J6) THEN
                BEEP
                GOTO REDO08
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S8 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO08
            END IF
              S8A = 200 - (S8 * 2)

         CASE 9
REDO09:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 9   :  ", S9

            S(X) = S9                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S9 = S(J6) THEN
                BEEP
                GOTO REDO09
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S9 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO09
            END IF
            S9A = 200 - (S9 * 2)

         CASE 10
REDO10:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 10  :  ", S10

            S(X) = S10                'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S10 = S(J6) THEN
                BEEP
                GOTO REDO10
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S10 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO10
            END IF
              S10A = 200 - (S10 * 2)

         CASE 11
REDO11:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 11  :  ", S11

            S(X) = S11                'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S11 = S(J6) THEN
                BEEP
                GOTO REDO11
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S11 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO11
            END IF
              S11A = 200 - (S11 * 2)

         CASE 12
REDO12:
            LOCATE 11 + X, 27
            INPUT "FOR ROTOR POSITION 12  :  ", S12

            S(X) = S12                'CHECK FOR DUPLICATE
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S12 = S(J6) THEN
                BEEP
                GOTO REDO12
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S12 THEN
                P2 = 1
                EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO12
            END IF
              S12A = 200 - (S12 * 2)

         END SELECT

  NEXT X

REDO13:
  COLOR 10, 0                         'GREEN/BLACK
  LOCATE 11 + X + 1, 27
  INPUT "FOR REVERSING ROTOR    :  ", SR

            S(13) = SR                 'CHECK FOR DUPLICATE
            FOR J6 = 1 TO 13
              IF J6 = 13 THEN EXIT FOR
              IF SR = S(J6) THEN
                BEEP
                GOTO REDO13
                EXIT FOR
              END IF
            NEXT J6

            P2 = 0
  FOR PN = 0 TO 24
    IF P(PN) = SR THEN
      P2 = 1
      EXIT FOR
    END IF
  NEXT PN

  IF P2 = 0 THEN
     BEEP
     GOTO REDO13
  END IF
  SRA = 200 - (SR * 2)
  COLOR 7, 0                          'WHITE/BLACK

  CHECKSUM1 = CHECKSUM1 + (S1 * 1) + (S2 * 2) + (S3 * 3) + (S4 * 4)
  CHECKSUM1 = CHECKSUM1 + (S5 * 5) + (S6 * 6) + (S7 * 7) + (S8 * 8)
  CHECKSUM1 = CHECKSUM1 + (S9 * 9) + (S10 * 10) + (S11 * 11) + (S12 * 12)
  CHECKSUM1 = CHECKSUM1 + (SR * 13)
  SLEEP 2

TAB04:   '---------------------------- EXTERNAL SETTINGS ROUTINE

  GOSUB TAB96                         'GET CHARACTER SET
  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  CLS
  PRINT "Internal Checksum = "; CHECKSUM1
  LOCATE 8, 33
  PRINT "(See your list)"
  LOCATE 10, 22
  PRINT "SET INITIAL ROTOR SETTINGS  (1 TO 100)"
  PRINT

  COLOR 14, 0                         'YELLOW/BLACK
  FOR X = 1 TO N
REENTER1:
    LOCATE 11 + X, 34
    PRINT USING "ROTOR ##"; X; : INPUT " :  ", T(X)
    IF T(X) > 100 OR T(X) < 1 THEN
      BEEP
      GOTO REENTER1
    END IF

    CHECKSUM = CHECKSUM + (T(X) * X)

    T(X) = 202 - (T(X) * 2)
    
  NEXT X

REENTER2:
  LOCATE 11 + X + 1, 24
  COLOR 10, 0
  INPUT "REVERSING ROTOR    :  ", TR

  IF TR > 100 OR TR < 1 THEN
    BEEP
    GOTO REENTER2
  END IF
  CORR$ = " "                         'INITIALIZE
  COLOR 7, 0                          'WHITE/BLACK

  CHECKSUM = CHECKSUM + (TR * X)

  TR = 202 - (TR * 2)
  

TAB05:    '--------------------------- INITIAL SETTINGS SHIFT ROUTINE

   FOR X = 1 TO N
     F$ = " ": H$ = " "

     SELECT CASE X

       CASE 1
          F$ = MID$(R1(1), 1, 200 - T(X))
          H$ = MID$(R1(1), 201 - T(X))
          R1(1) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(1), 1, 200 - T(X))
          H$ = MID$(P0(1), 201 - T(X))
          P0(1) = H$ + F$
          RB$(1) = MID$(P0(1), 1, 2)    'BOTTOM OF SCREEN DISPLAY
   
       CASE 2
          F$ = MID$(R1(2), 1, 200 - T(X))
          H$ = MID$(R1(2), 201 - T(X))
          R1(2) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(2), 1, 200 - T(X))
          H$ = MID$(P0(2), 201 - T(X))
          P0(2) = H$ + F$
          RB$(2) = MID$(P0(2), 1, 2)
   
       CASE 3
          F$ = MID$(R1(3), 1, 200 - T(X))
          H$ = MID$(R1(3), 201 - T(X))
          R1(3) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(3), 1, 200 - T(X))
          H$ = MID$(P0(3), 201 - T(X))
          P0(3) = H$ + F$
          RB$(3) = MID$(P0(3), 1, 2)
         
       CASE 4
          F$ = MID$(R1(4), 1, 200 - T(X))
          H$ = MID$(R1(4), 201 - T(X))
          R1(4) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(4), 1, 200 - T(X))
          H$ = MID$(P0(4), 201 - T(X))
          P0(4) = H$ + F$
          RB$(4) = MID$(P0(4), 1, 2)
      
       CASE 5
          F$ = MID$(R1(5), 1, 200 - T(X))
          H$ = MID$(R1(5), 201 - T(X))
          R1(5) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(5), 1, 200 - T(X))
          H$ = MID$(P0(5), 201 - T(X))
          P0(5) = H$ + F$
          RB$(5) = MID$(P0(5), 1, 2)
      
       CASE 6
          F$ = MID$(R1(6), 1, 200 - T(X))
          H$ = MID$(R1(6), 201 - T(X))
          R1(6) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(6), 1, 200 - T(X))
          H$ = MID$(P0(6), 201 - T(X))
          P0(6) = H$ + F$
          RB$(6) = MID$(P0(6), 1, 2)

       CASE 7
          F$ = MID$(R1(7), 1, 200 - T(X))
          H$ = MID$(R1(7), 201 - T(X))
          R1(7) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(7), 1, 200 - T(X))
          H$ = MID$(P0(7), 201 - T(X))
          P0(7) = H$ + F$
          RB$(7) = MID$(P0(7), 1, 2)
      
       CASE 8
          F$ = MID$(R1(8), 1, 200 - T(X))
          H$ = MID$(R1(8), 201 - T(X))
          R1(8) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(8), 1, 200 - T(X))
          H$ = MID$(P0(8), 201 - T(X))
          P0(8) = H$ + F$
          RB$(8) = MID$(P0(8), 1, 2)
      
       CASE 9
          F$ = MID$(R1(9), 1, 200 - T(X))
          H$ = MID$(R1(9), 201 - T(X))
          R1(9) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(9), 1, 200 - T(X))
          H$ = MID$(P0(9), 201 - T(X))
          P0(9) = H$ + F$
          RB$(9) = MID$(P0(9), 1, 2)

       CASE 10
          F$ = MID$(R1(10), 1, 200 - T(X))
          H$ = MID$(R1(10), 201 - T(X))
          R1(10) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(10), 1, 200 - T(X))
          H$ = MID$(P0(10), 201 - T(X))
          P0(10) = H$ + F$
          RB$(10) = MID$(P0(10), 1, 2)

       CASE 11
          F$ = MID$(R1(11), 1, 200 - T(X))
          H$ = MID$(R1(11), 201 - T(X))
          R1(11) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(11), 1, 200 - T(X))
          H$ = MID$(P0(11), 201 - T(X))
          P0(11) = H$ + F$
          RB$(11) = MID$(P0(11), 1, 2)

       CASE 12
          F$ = MID$(R1(12), 1, 200 - T(X))
          H$ = MID$(R1(12), 201 - T(X))
          R1(12) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(12), 1, 200 - T(X))
          H$ = MID$(P0(12), 201 - T(X))
          P0(12) = H$ + F$
          RB$(12) = MID$(P0(12), 1, 2)
      
    END SELECT

  NEXT X
                                      'REVERSING ROTOR
          F$ = " ": H$ = " "
          F$ = MID$(RR$, 1, 200 - TR)
          H$ = MID$(RR$, 201 - TR)
          RR$ = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(PR$, 1, 200 - TR)
          H$ = MID$(PR$, 201 - TR)
          PR$ = H$ + F$
          R13$ = MID$(PR$, 1, 2)

  CLS
  IF CORR$ = "Y" THEN GOTO TAB07

REPEAT04:

  LOCATE 10, 21
  PRINT "DO YOU WANT TO SUPER-ENCIPHER (Y or N) ?"
REPEAT05: Q5$ = INKEY$: IF Q5$ = "" THEN GOTO REPEAT05
  IF Q5$ <> "N" AND Q5$ <> "Y" THEN GOTO REPEAT04
  IF Q5$ = "N" THEN TABLENO = 0       'NO SUPERENCIPHERMENT
TAB07:

  IF Q5$ = "Y" THEN GOSUB TAB64       'SUPERENCIPHERMENT TABLES
  
  IF CORR$ = "Y" THEN GOTO TAB09
                                    
REPEAT06:  '-------------------------- START SCREEN

  F1 = FRE("")
  CLS
  GOSUB TAB113                        'CHECKSUM ROUTINE

  LOCATE 10, 20
  COLOR 2, 0
  PRINT "To stop operations and :"
  LOCATE 12, 20
  PRINT "1.  Print text     :  Press ";
  COLOR 4, 15                         'RED,BRIGHT WHITE
  PRINT " \ "
  LOCATE 14, 20
  COLOR 2, 0                          'GREEN, BLACK
  PRINT "2.  Correct input  :  Press ";
  COLOR 4, 15                         'RED/BRIGHT WHITE
  PRINT " Shift & | "
  COLOR 7, 0                          'WHITE, BLACK

TAB09: '------------------------------ INITIALIZE OUTPUT LOCATIONS

  C = 2: C1 = 1                       'COLUMNS - ENCODING
  D = 1: D1 = 2                       'COLUMNS - DECODING
  F = 1                               'LINES - DECODING
  G = 3                               'LINES - DECODING
  O$ = " "
  M$ = "  "
  J$ = "  "
 
  COLOR 14, 0                         'YELLOW ON BLACK
  LOCATE 25, 1                        'BOTTOM LINE OF SCREEN
  GOSUB TAB106                        'COPY ROTORS AT BEGINNING OF SCREEN

  PRINT "Press ENTER key to start - or - to make the next screen";
  PRINT "                         ";
  DO
  LOOP WHILE INKEY$ = ""

  COLOR 7, 0                          'WHITE ON BLACK
  CLS
  IF B$ = "|" THEN GOTO SKIP12
  LOCATE 10, 30
  COLOR 11, 0                         'LIGHT CYAN/BLACK
  IF O$ = "|" OR U1 > 1 OR CORR$ = "Y" THEN
     PRINT "CONTINUE ENTERING MESSAGE"
  ELSE
     PRINT "START ENTERING MESSAGE"
  END IF
  COLOR 7, 0                          'WHITE/BLACK
SKIP12:
  GOSUB TAB109                        'DISPLAY ROTORS AT BOTTOM OF SCREEN

  Z$ = O$
  IF O$ = "\" THEN GOTO TAB50         'END AND PRINT
  IF O$ = "|" THEN GOTO TAB30         'CORRECTION ROUTINE

  I = 0: K = 0

TAB10:  '---------------------------- 'E/D SWITCH
  
  IF Q$ = "1" THEN GOTO TAB11         'ENCIPHER
  IF Q$ = "2" THEN GOTO TAB14         'DECIPHER
  GOTO REPEAT06                       'CHECK FOR CORRECT INPUT


TAB11: '---------------ENCIPHER------- ENTER CLEARTEXT CHARACTERS

  IF X5 = 0 THEN GOTO TAB12           'TO KEYBOARD ENTRY IF X5=0

  X4 = X4 + 1                         'AUTOMATIC ENTRY WHEN CORRECTING
  IF X4 >= X2 THEN                    'LIMIT NUMBER OF AUTOMATIC INPUTS TO X2
    LOCATE 10, 30
    COLOR 11, 0                       'LIGHT CYAN/BLACK
    PRINT "CONTINUE ENTERING MESSAGE"
    COLOR 7, 0                        'WHITE/BLACK
    GOTO TAB12
  END IF


  B$ = MID$(K1$, X4, 1)               'SELECT X4th ENTRY FOR INPUT

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  GOTO TAB13


TAB12:  '----------------------------- DATA ENTRY ROUTINE (KEYBOARD)
 
  E5 = 1                              'BLANK ABOVE MESSAGE FLAG
  X5 = 0                              'SET FOR KEYBOARD ENTRY

  DO
    B$ = INKEY$                       'ENTER CLEARTEXT
  LOOP UNTIL B$ <> ""

  IF U1 = MAXMSG THEN B$ = "\"        'TO LIMIT INPUT CHARACTERS

  IF B$ = "\" OR B$ = "|" THEN
    LOCATE 10, 30
    PRINT B4$                         'ERASE START MESSAGE SIGN
    GOTO TAB13                        'TO PROCESS INPUT
  END IF

  IF E5 = 1 THEN
    LOCATE 10, 30
    PRINT B4$                         'ERASE START MESSAGE SIGN
  END IF
                                      'CONVERT INPUT USING CHARACTER SET BY
  B1 = INSTR(Y4$, B$)                 'DETERMINING INPUT POSITIONAL VALUE

  IF B1 = 0 AND B$ <> "A" THEN        'B1=0 MEANS B$ NOT IN Y4$
    BEEP
    GOTO TAB12                        'RE-ENTER INPUT
  END IF

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  
TAB13:  '----------------------------- PROCESS INPUT

  IF B$ = "|" THEN                    'CORRECTION PROCEDURE
    CORR$ = "Y"
    M5 = 0
  END IF

  Z$ = B$
  IF B$ = "\" THEN GOTO TAB50         'GO TO PRINT ROUTINE
  IF B$ = "|" THEN GOTO TAB30         'GO TO CORECTION PROCEDURE

  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK
  PRINT "Enter '\' to end message.   Press 'Shift |' to make correction.";
  U1 = U1 + 1                         'COUNT INPUT
  LOCATE 24, 65
  IF U1 < (MAXMSG - 2) THEN
     COLOR 14, 0                      'YELLOW/BLACK
     ELSE
     COLOR 27, 0                      'BLINK CYAN/BLACK - END OF 12TH SCREEN
     END IF
  PRINT USING "Input No. ####"; U1;
  COLOR 7, 0                          'WHITE/BLACK

  LOCATE F, C
  PRINT B$                            'PRINT CLEARTEXT INPUT
  C = C + 3

  A = INSTR(Y4$, B$)                  'FIND INPUT POSITION IN BASE CHAR SET
  A$ = C$(A)                          'CONVERT CHARACTER TO CODE NUMBER
  IF A$ = "00" THEN A$ = "100"        'ADJUST POSITION VALUE
  IF B$ = "" THEN A$ = Y1$            'ASSIGN CODE NUMBER TO "SPACE"
  I3(VAL(A$)) = I3(VAL(A$)) + 1       'COUNT OF INPUT CHARACTERS

  GOSUB TAB78                         'TALLY INPUT COUNT

  GOSUB TAB60                         'THRU PLUGBOARD

  GOTO TAB26                          'TO COMMON OPERATION


TAB14: '------------------------------ DECRYPTION ROUTINE SWITCHES

  IF X5 = 0 THEN GOTO TAB20           'TO KEYBOARD ENTRY IF X5=0

  Z5 = 1                              'AUTOMATIC ENTRY WHEN CORRECTING
  IF X4 >= (X2 * 2) - 2 THEN GOTO TAB20  'LIMIT NUMBER OF AUTOMATIC INPUTS
  A$ = MID$(I1$, Z5 + X4, 2)          'SELECT X4th ENTRY FOR INPUT
  X4 = X4 + 2
  GOTO TAB23                          'PROCESS INPUT

  IF CORR$ <> "Y" THEN GOTO TAB20     'NO CORRECTIONS
  T4 = T4 + 2

  IF T4 >= T2 - 1 THEN GOTO TAB20     'RECOVERY OF STORED INPUT
  A$ = MID$(I1$, T4, 2)

  IF Q5$ = "Y" THEN GOTO TAB23        'FOR SUPER DECRYPTION
  GOTO TAB24

TAB20: '------------------------------ CIPHER TEXT INPUT
  
  E5 = 1                              'ERASE START MESSAGE FLAG
  F1 = FRE("")
  DO                                  'INPUT 1ST CIPHER DIGIT
    A1$ = INKEY$
  LOOP UNTIL A1$ <> ""

    IF ASC(A1$) = 13 THEN             'CHECK FOR BLANK ENTRY
      BEEP
      GOTO TAB20
    END IF

  Z$ = A1$
  IF A1$ = "\" THEN GOTO TAB50        'GO TO PRINT ROUTINE
  IF A1$ = "|" THEN GOTO TAB30        'GO TO END OF PROGRAM

  IF Q5$ = "N" THEN                   'NOT SUPER ENCIPHERED
     SELECT CASE A1$                  '1ST CHARACTER ENTERED
       CASE "0" TO "9"                'MUST BE NUMERIC
         GOTO TAB21                   'O.K.
       CASE ELSE                      'NOT NUMERIC (ERROR)
         BEEP
         GOTO TAB20                   'RE-ENTER
     END SELECT
  END IF

  IF Q5$ = "Y" THEN                   'SUPER ENCIPHERED
    SELECT CASE A1$                   '1ST CHARACTER ENTERED
      CASE "A" TO "Z"                 'MUST BE ALPHA
        GOTO TAB21                    'O.K.
      CASE ELSE                       'NOT ALPHA (ERROR)
        BEEP
        GOTO TAB20                    'RE-ENTER
    END SELECT
  END IF

TAB21:
 
  DO                                  'INPUT 2ND CIPHER DIGIT
    A2$ = INKEY$
  LOOP UNTIL A2$ <> ""
    IF ASC(A2$) = 13 THEN             'CHECK FOR BLANK ENTRY
      BEEP
      GOTO TAB20
    END IF

  IF Q5$ = "N" THEN                   'NOT SUPER ENCIPHERED
     SELECT CASE A2$                  '2ND CHARACTER ENTERED
       CASE "0" TO "9"                'MUST BE NUMERIC
         GOTO TAB22                   'O.K.
       CASE ELSE                      'NOT NUMERIC (ERROR)
         BEEP
         GOTO TAB20                   'RE-ENTER BOTH DIGITS
     END SELECT
  END IF

  IF Q5$ = "Y" THEN                   'SUPER ENCIPHERED
    SELECT CASE A2$                   '2ND CHARACTER ENTERED
      CASE "A" TO "Z"                 'MUST BE ALPHA
        GOTO TAB22                    'O.K.
      CASE ELSE                       'NOT ALPHA (ERROR)
        BEEP
        GOTO TAB20                    'RE-ENTER BOTH CHARACTERS
    END SELECT
  END IF

TAB22:

   A$ = A1$ + A2$                     'COMBINE

  IF E5 = 1 THEN                      'ERASE START MESSAGE SIGN
    LOCATE 10, 30
    PRINT B4$
  END IF

TAB23:  ' ---------------------------- SUPER DECIPHERMENT PRINTING

  A4$ = A$
  IF Q5$ = "Y" THEN GOSUB TAB72       'SUPER DECIPHERMENT

TAB24:  ' ---------------------------- SUPER ENCIPHERMENT INPUT

  A3$ = A$                            'SAVE FOR PRINTING
  IF Q5$ = "Y" THEN A3$ = A4$         'SUPERDECIPHERMENT INPUT
  GOSUB TAB60                         'THRU PLUGBOARD
  LOCATE F, D
  PRINT A3$
  IF A$ = "00" THEN A$ = "100"
  D = D + 3

TAB26: '------------------------------ COMMON TO ENCIPHER & DECIPHER

  IF A$ = "00" THEN A$ = "100"
  L = (VAL(A$) * 2) - 1               'ENTRY STATOR

  P$ = P0(1)                          'ROTOR 1
  R$ = R1(1)
  GOSUB TAB38
  J = 1: IF J = N THEN GOTO RR

  P$ = P0(2)                          'ROTOR 2
  R$ = R1(2)
  GOSUB TAB38
  J = 2: IF J = N THEN GOTO RR

  P$ = P0(3)                          'ROTOR 3
  R$ = R1(3)
  GOSUB TAB38
  J = 3: IF J = N THEN GOTO RR

  P$ = P0(4)                          'ROTOR 4
  R$ = R1(4)
  GOSUB TAB38
  J = 4: IF J = N THEN GOTO RR

  P$ = P0(5)                          'ROTOR 5
  R$ = R1(5)
  GOSUB TAB38
  J = 5: IF J = N THEN GOTO RR

  P$ = P0(6)                          'ROTOR 6
  R$ = R1(6)
  GOSUB TAB38
  J = 6: IF J = N THEN GOTO RR

  P$ = P0(7)                          'ROTOR 7
  R$ = R1(7)
  GOSUB TAB38
  J = 7: IF J = N THEN GOTO RR

  P$ = P0(8)                          'ROTOR 8
  R$ = R1(8)
  GOSUB TAB38
  J = 8: IF J = N THEN GOTO RR

  P$ = P0(9)                          'ROTOR 9
  R$ = R1(9)
  GOSUB TAB38
  J = 9: IF J = N THEN GOTO RR

  P$ = P0(10)                         'ROTOR 10
  R$ = R1(10)
  GOSUB TAB38
  J = 10: IF J = N THEN GOTO RR

  P$ = P0(11)                         'ROTOR 11
  R$ = R1(11)
  GOSUB TAB38
  J = 11: IF J = N THEN GOTO RR
 
  P$ = P0(12)                         'ROTOR 12
  R$ = R1(12)
  GOSUB TAB38
  J = 12: IF J = N THEN GOTO RR

RR:
  P$ = PR$                            'REVERSING ROTOR
  R$ = RR$
  GOSUB TAB38

  ON N GOTO R01, R02, R03, R04, R05, R06, R07, R08, R09, R10, R11, R12

R12:
  P$ = R1(12)                         'ROTOR 12
  R$ = P0(12)
  GOSUB TAB38
 
R11:
  P$ = R1(11)                         'ROTOR 11
  R$ = P0(11)
  GOSUB TAB38
 
R10:
  P$ = R1(10)                         'ROTOR 10
  R$ = P0(10)
  GOSUB TAB38
 
R09:
  P$ = R1(9)                          'ROTOR 9
  R$ = P0(9)
  GOSUB TAB38
 
R08:
  P$ = R1(8)                          'ROTOR 8
  R$ = P0(8)
  GOSUB TAB38
 
R07:
  P$ = R1(7)                          'ROTOR 7
  R$ = P0(7)
  GOSUB TAB38
 
R06:
  P$ = R1(6)                          'ROTOR 6
  R$ = P0(6)
  GOSUB TAB38
 
R05:
  P$ = R1(5)                          'ROTOR 5
  R$ = P0(5)
  GOSUB TAB38
 
R04:
  P$ = R1(4)                          'ROTOR 4
  R$ = P0(4)
  GOSUB TAB38
  
R03:
  P$ = R1(3)                          'ROTOR 3
  R$ = P0(3)
  GOSUB TAB38
 
R02:
  P$ = R1(2)                          'ROTOR 2
  R$ = P0(2)
  GOSUB TAB38
 
R01:
  P$ = R1(1)                          'ROTOR 1
  R$ = P0(1)
  GOSUB TAB38
 
  IF Q$ = "2" THEN GOTO TAB28         'TO PRINT CLEARTEXT OUTPUT

  R$ = P0$                            'EXIT STATOR
  LOCATE G, C1
  J$ = MID$(R$, L, 2)

  A$ = J$
  GOSUB TAB60                         'THRU PLUGBOARD
  J$ = A$

  IF Q5$ = "Y" THEN GOSUB TAB70       'SUPER ENCIPHER INTO ALPHA

  IF G = 23 AND W = 161 THEN
     PRINT J$;                        'PRINT OUTPUT CODE
  ELSE
     PRINT J$                         'PRINT OUTPUT CODE
  END IF

  IF Q5$ <> "Y" THEN GOSUB TAB80      'COUNT OUTPUT CODE
 
  O(VAL(J$)) = O(VAL(J$)) + 1         'OUTPUT COUNT

  GOSUB TAB48                         'STORE FOR PRINTER

  GOSUB TAB44                         'TO ROTOR SHIFT ROUTINE

  GOSUB TAB40                         'SCREEN END-OF-LINE ROUTINE

  IF G > 23 THEN GOTO TAB09           'CLEAR AND START NEW SCREEN

  GOTO TAB10                          'TO BEGINING FOR NEXT INPUT


TAB28: '------------------------------ DECIPHER ROUTINE

  L = 1
  FOR U = 1 TO 200 STEP 2
    IF M$ = MID$(P0(1), U, 2) THEN EXIT FOR
    L = L + 1
  NEXT U

  GOSUB TAB62                         'THRU PLUGBOARD

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  G$ = MID$(Y4$, L, 1)                'CONVERT TO CLEARTEXT CHARACTER
  LOCATE G, D1
  PRINT G$;                           'PRINT CLEARTEXT OUTPUT

  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK
  PRINT "Enter '\' to end message.   Press 'Shift |' to make correction.";
  U1 = U1 + 1                         'COUNT INPUT
  LOCATE 24, 65
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT USING "Output No. ####"; U1;
  COLOR 7, 0                          'WHITE/BLACK

  GOSUB TAB48                         'STORE FOR PRINTER

  GOSUB TAB44                         'SHIFT ROUTINE
  
  GOSUB TAB40                         'SCREEN END-OF-LINE ROUTINE

  IF G > 23 THEN GOTO TAB09           'CLEAR AND START NEW SCREEN

  GOTO TAB10                          'START WITH NEW INPUT


TAB30:  '----------------------------- END OF MESSAGE ROUTINE

  HC = HC - (FIX(HC / 100) * 100)
  IF B$ = "\" OR A1$ = "\" THEN GOTO TAB32
  
  GOTO TAB34

TAB32:  '----------------------------- PRINT MESSAGE STATISTICS
 
  LPRINT "TOTAL INPUT CHARACTERS IS "; K1;

  IF Q5$ = "Y" THEN GOTO TAB34        'SKIP IF SUPERENCIPHERED

  LPRINT TAB(57); "HASH TOTAL OF CODE IS "; C$(HC)

  LPRINT
  LPRINT "COL CHECK TOTALS"
  LPRINT

  FOR X = 1 TO 27
    X9 = X9 + C4(X)
    A = C4(X) / 100
    B = INT(A)
    C = (A - B) * 100
    IF C = 0 THEN C = 100
    IF C4(X) = 0 THEN
      LPRINT USING "\\ "; "  ";
      GOTO SKIP01
    END IF
    LPRINT USING "\\ "; C$(C);
SKIP01:
  NEXT X

  LPRINT : LPRINT : LPRINT "TOTAL COLUMNS = "; X9

  LPRINT : LPRINT "ROW CHECK TOTALS"
  LPRINT
  FOR X = 1 TO X6
    Y6 = Y6 + 1                       'LINE POSITION COUNTER
    X8 = X8 + R4(X)
    A = R4(X) / 100
    B = INT(A)
    R = (A - B) * 100
    IF R = 0 THEN R = 100

    IF Y6 = 28 THEN                   'LIMIT LINE TO 27 POSITIONS
      LPRINT : LPRINT
      Y6 = 0
    END IF

    LPRINT USING "\\ "; C$(R);
  NEXT X

  LPRINT : LPRINT : LPRINT "TOTAL ROWS    = "; X8
  LPRINT

TAB34: '------------------------------ END OF MESSAGE QUESTIONS
 
  IF B$ = "|" OR A1$ = "|" THEN       'CORRECTION FLAG
     CORR$ = "Y"
     GOTO TAB35
   END IF

  IF Q$ = "2" THEN GOTO TAB37         'END PRINTING AND FORM FEED

  LOCATE 24, 1
  PRINT STRING$(80, " ");
  LOCATE 25, 1
  PRINT STRING$(80, " ");
 
  GOSUB TAB102                        'PRINT MESSAGE IN TRANSMISSION FORM

  LOCATE 25, 1
  PRINT STRING$(80, " ");
  COLOR 14, 0                         'YELLOW/BLACK
  LOCATE 25, 1
  INPUT ; "IS THERE ANOTHER (NEW) MESSAGE (Y or N) - - - - - - - ", ANOTHER$
  IF ANOTHER$ = "Y" THEN
     Q5$ = " "
     CORR$ = " "
     LPRINT CHR$(12);                 'FORM FEED
     GOSUB TAB114                     'RESTORE ORIGINAL SETTINGS
     GOTO TAB04                       'ORIGINAL SETTINGS ROUTINE
   END IF

  GOTO TAB36                          'TO END OF SESSION
  
TAB35: '------------------------------ CORRECTION PROCEDURE

  I1$ = I(1)                          'CUMULATIVE OUTPUT CODE
  I1$ = RTRIM$(I1$)                   'CUMULATIVE OUTPUT CODE
  K1$ = K(1)                          'CUMULATIVE INPUT CLEARTEXT
  X5 = 1                              'GO TO AUTOMATIC INPUT MODE
  X4 = 0                              'INPUT COUNTER FOR AUTOMATIC INPUT
  
  GOSUB TAB108                        'POSITION NUMBERS ON SCREEN
  
  T4 = -1
  T2 = LEN(I1$)                       'COUNT OF OUTPUT CHARACTERS
  W = 0                               'RESET SCREEN INPUT COUNT
  W1 = 1
  W2 = 1
 
  GOTO TAB03                          'BEGIN NEW MESSAGE

TAB36:  '----------------------------- END SESSION
 
  CLS
  COLOR 14, 0                         'YELLOW, BLACK
  LOCATE 10, 10
  INPUT "DO YOU WANT A CHARACTER FREQUENCY ANALYSIS (Y or N) ", A5$
  COLOR 7, 0                          'WHITE, BLACK
  IF A5$ = "N" THEN GOTO TAB37

  GOSUB TAB82                         'INPUT ANALYSIS
  IF Q5$ <> "Y" THEN GOSUB TAB84      'PRINT OUTPUT ANALYSIS
  IF Q5$ <> "Y" THEN GOTO TAB37       'Q5$ = "Y" = SUPERENCIPHERMENT
  GOSUB TAB98                         'PRINT ANALYSIS OF SUPERENCIPHERMENT

TAB37:  '----------------------------- PRINT MESSAGE
  
  LPRINT CHR$(12);                    'FORM FEED

  IF Q$ = "2" THEN                    'DECRYPTION MODE (2 = YES)
    LPRINT CHR$(27); "l"; CHR$(4):    'SET LEFT MARGIN TO 4 CHARACTERS
    LPRINT "Message No.---------------------From---------";
    LPRINT "-------------------------Date/Time of receipt"
    LPRINT ":                               :            ";
    LPRINT "                         :         /        :"
    LPRINT ":                               :            ";
    LPRINT "                         :        /         :"
    FOR V = 1 TO 90: LPRINT "-"; : NEXT V
    PRINT : LPRINT : LPRINT
    V1 = 0: V2 = 0
    DO UNTIL V1 >= K1
      DO UNTIL V2 = 90
        V1 = V1 + 1
        V2 = V2 + 1
        LPRINT MID$(K2(1), V1, 1);
      LOOP
        LPRINT : LPRINT : LPRINT
        V2 = 0
    LOOP
    LPRINT CHR$(27); "l"; CHR$(9);    'RESTORE RIGHT MARGIN
    LPRINT CHR$(12);

  END IF
 
  CLS
  COLOR 14, 0                         'YELLOW/BLACK
  LOCATE 23, 1
  PRINT "IS THERE ANOTHER MESSAGE ";
  INPUT ; "WITH SAME INTERNAL SETTINGS (Y or N) ", ANOTHER$
  IF ANOTHER$ = "Y" THEN
     GOSUB TAB114
     GOTO TAB04
   END IF
   CLS

END

TAB38:  ' ---------------------------- POSITION OF CODE NUMBER M$ IN P$
  
  M$ = MID$(P$, L, 2)
  L = 1
  FOR U = 1 TO 200 STEP 2
    IF M$ = MID$(R$, U, 2) THEN EXIT FOR
    L = L + 2
  NEXT U

  RETURN


TAB40:  '----------------------------- SCREEN END-OF-LINE ROUTINE

  C1 = C1 + 3: D1 = D1 + 3
  IF C1 > 81 OR D1 > 81 THEN
     LOCATE G + 1, 1
     COLOR 14                         'YELLOW
     FOR V = 1 TO 80: PRINT "-"; : NEXT V
     IF G = 23 THEN
        PRINT ;
     ELSE
        PRINT
     END IF

     COLOR 7                          'WHITE
     C1 = 1
     C = 2
     D = 1
     D1 = 2
     F = F + 4
     G = G + 4
  END IF

  RETURN
    

TAB44:  '----------------------------- SHIFT ROUTINE
  
  FOR X = 1 TO N
    F$ = " ": H$ = " "

    SELECT CASE X

       CASE 1
          F$ = MID$(R1(1), 1, 200 - S1A)
          H$ = MID$(R1(1), 201 - S1A)
          R1(1) = H$ + F$             'ROTOR DESTINATION SIDE
          F$ = " ": H$ = " "
          F$ = MID$(P0(1), 1, 200 - S1A)
          H$ = MID$(P0(1), 201 - S1A)
          P0(1) = H$ + F$             'ROTOR POSITION SIDE (00-99)
          RB$(1) = MID$(P0(1), 1, 2)  'BOTTOM OF SCREEN DISPLAY

       CASE 2
          F$ = MID$(R1(2), 1, 200 - S2A)
          H$ = MID$(R1(2), 201 - S2A)
          R1(2) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(2), 1, 200 - S2A)
          H$ = MID$(P0(2), 201 - S2A)
          P0(2) = H$ + F$
          RB$(2) = MID$(P0(2), 1, 2)

       CASE 3
          F$ = MID$(R1(3), 1, 200 - S3A)
          H$ = MID$(R1(3), 201 - S3A)
          R1(3) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(3), 1, 200 - S3A)
          H$ = MID$(P0(3), 201 - S3A)
          P0(3) = H$ + F$
          RB$(3) = MID$(P0(3), 1, 2)

       CASE 4
          F$ = MID$(R1(4), 1, 200 - S4A)
          H$ = MID$(R1(4), 201 - S4A)
          R1(4) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(4), 1, 200 - S4A)
          H$ = MID$(P0(4), 201 - S4A)
          P0(4) = H$ + F$
          RB$(4) = MID$(P0(4), 1, 2)

       CASE 5
          F$ = MID$(R1(5), 1, 200 - S5A)
          H$ = MID$(R1(5), 201 - S5A)
          R1(5) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(5), 1, 200 - S5A)
          H$ = MID$(P0(5), 201 - S5A)
          P0(5) = H$ + F$
          RB$(5) = MID$(P0(5), 1, 2)

       CASE 6
          F$ = MID$(R1(6), 1, 200 - S6A)
          H$ = MID$(R1(6), 201 - S6A)
          R1(6) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(6), 1, 200 - S6A)
          H$ = MID$(P0(6), 201 - S6A)
          P0(6) = H$ + F$
          RB$(6) = MID$(P0(6), 1, 2)

       CASE 7
          F$ = MID$(R1(7), 1, 200 - S7A)
          H$ = MID$(R1(7), 201 - S7A)
          R1(7) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(7), 1, 200 - S7A)
          H$ = MID$(P0(7), 201 - S7A)
          P0(7) = H$ + F$
          RB$(7) = MID$(P0(7), 1, 2)
      
       CASE 8
          F$ = MID$(R1(8), 1, 200 - S8A)
          H$ = MID$(R1(8), 201 - S8A)
          R1(8) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(8), 1, 200 - S8A)
          H$ = MID$(P0(8), 201 - S8A)
          P0(8) = H$ + F$
          RB$(8) = MID$(P0(8), 1, 2)
      
       CASE 9
          F$ = MID$(R1(9), 1, 200 - S9A)
          H$ = MID$(R1(9), 201 - S9A)
          R1(9) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(9), 1, 200 - S9A)
          H$ = MID$(P0(9), 201 - S9A)
          P0(9) = H$ + F$
          RB$(9) = MID$(P0(9), 1, 2)
      
       CASE 10
          F$ = MID$(R1(10), 1, 200 - S10A)
          H$ = MID$(R1(10), 201 - S10A)
          R1(10) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(10), 1, 200 - S10A)
          H$ = MID$(P0(10), 201 - S10A)
          P0(10) = H$ + F$
          RB$(10) = MID$(P0(10), 1, 2)

       CASE 11
          F$ = MID$(R1(11), 1, 200 - S11A)
          H$ = MID$(R1(11), 201 - S11A)
          R1(11) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(11), 1, 200 - S11A)
          H$ = MID$(P0(11), 201 - S11A)
          P0(11) = H$ + F$
          RB$(11) = MID$(P0(11), 1, 2)

       CASE 12
          F$ = MID$(R1(12), 1, 200 - S12A)
          H$ = MID$(R1(12), 201 - S12A)
          R1(12) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(12), 1, 200 - S12A)
          H$ = MID$(P0(12), 201 - S12A)
          P0(12) = H$ + F$
          RB$(12) = MID$(P0(12), 1, 2)
      
       END SELECT

  NEXT X
                                      'REVERSING ROTOR
          F$ = " ": H$ = " "
          F$ = MID$(RR$, 1, 200 - SRA)
          H$ = MID$(RR$, 201 - SRA)
          RR$ = H$ + F$

          F$ = " ": H$ = " "
          F$ = MID$(PR$, 1, 200 - SRA)
          H$ = MID$(PR$, 201 - SRA)
          PR$ = H$ + F$
          R13$ = MID$(PR$, 1, 2)

  GOSUB TAB109

  RETURN
 
TAB48:   '--------------------------- 'STORE DATA FOR PRINTER AND PRINT

  SELECT CASE Q$
     CASE "1"                         'ENCIPHER
        K = K + 1                     'CLEARTEXT INPUT COUNTER
        I = I + 1                     'CODE OUTPUT COUNTER
        MID$(K(1), K, 1) = B$         'CLEAR INPUT
        MID$(I(1), I, 2) = J$         'CODE OUTPUT
        I = I + 1
        HC = HC + VAL(J$)             'ACCUMULATE OUTPUT HASH COUNT TOTAL
        O1$ = "ENCRYPTION"

     CASE "2"                         'DECIPHER
        I = I + 1                     'CODE INPUT COUNTER
        K = K + 1                     'CLEARTEXT OUTPUT COUNTER
        MID$(I(1), I, 2) = A3$        'CODE INPUT
        MID$(K(1), K, 1) = G$         'CLEAR OUTPUT
        I = I + 1
        HC = HC + VAL(A3$)            'ACCUMULATE INPUT HASH COUNT TOTAL
        O1$ = "DECRYPTION"

  END SELECT

  W = W + 1                           'COUNTER FOR BEEPS
  IF W > 158 THEN BEEP                'END-OF-SCREEN CHECK & WARNING
  IF W = 162 THEN                     'PRINT SCREEN CONTENTS
    GOSUB TAB50
  END IF

  RETURN

TAB50:   ' -------------------------- 'PRINT MESSAGE SETTINGS
 
  H2 = H2 + 324: H1 = H2
  MID$(I2(1), H1 - 323, 324) = I(1)        'ACCUMULATE INPUT
  MID$(K2(1), (H1 / 2) - 161, 162) = K(1)  'ACCUMULATE OUTPUT

  IF M = 1 THEN GOTO TAB55            'SKIP AFTER FIRST PAGE
  M = 1
  O2$ = "\        \                                            "
  O3$ = "\        \  \      \ Hours"
  LPRINT USING O2$; O1$;
  LPRINT USING O3$; D10$; T10$
  GOSUB TAB116                        'SEPARATOR LINE

  LPRINT "No. of PB Connections     "; C$(N1)
  LPRINT

  X1 = 0
  FOR V5 = 1 TO 8
    IF V5 > 1 THEN GOTO SKIP02
    LPRINT "Plugboard Connections     ";
    GOTO SKIP03
  
SKIP02:
    
    LPRINT B4$;

SKIP03:
  
  FOR V6 = 1 TO 7
    X1 = X1 + 1
    IF PB$(X1) = "    " THEN GOTO SKIP04
    LPRINT "("; PB$(X1); ")  ";
    IF X1 >= 50 THEN
      X1 = 51
      EXIT FOR
      END IF
SKIP04:
  NEXT V6

  LPRINT : LPRINT
  IF X1 = 51 THEN EXIT FOR
  IF PB$(X1 + 1) = "    " THEN EXIT FOR
  NEXT V5

  LPRINT "No. of Rotors             "; C$(N)
  LPRINT

  LPRINT "Rotors Sequence           ";
  FOR X = 1 TO N: LPRINT C$(A(X)); "  "; : NEXT X
  LPRINT : LPRINT

  LPRINT "Rotors Orientation        ";
  FOR X = 1 TO N: LPRINT USING "0\\ "; A$(X); : NEXT X
  LPRINT : LPRINT
 
  LPRINT "Reversing Rotor No.       "; C$(REVROTRNUM)
  LPRINT

  LPRINT "Rotors Rotation Values    ";
  FOR X = 1 TO N
    SELECT CASE X
       CASE 1
         LPRINT C$(S1); "  ";
       CASE 2
         LPRINT C$(S2); "  ";
       CASE 3
         LPRINT C$(S3); "  ";
       CASE 4
         LPRINT C$(S4); "  ";
       CASE 5
         LPRINT C$(S5); "  ";
       CASE 6
         LPRINT C$(S6); "  ";
       CASE 7
         LPRINT C$(S7); "  ";
       CASE 8
         LPRINT C$(S8); "  ";
       CASE 9
         LPRINT C$(S9); "  ";
       CASE 10
         LPRINT C$(S10); "  ";
       CASE 11
         LPRINT C$(S11); "  ";
       CASE 12
         LPRINT C$(S12); "  ";
    END SELECT
  NEXT X
  LPRINT : LPRINT

  LPRINT "Rev Rotor Rotation Value  "; C$(SR)
  LPRINT
 
  LPRINT "Character Set (CS) No.    "; C$(CHARNUM)
  LPRINT

  LPRINT "CS Rotation Value         "; C$(RV);
  LPRINT TAB(57);
  LPRINT USING "Internal Checksum ######"; CHECKSUM1

  GOSUB TAB116                        'SEPARATOR LINE
  
  LPRINT "Rotors Initial Settings   ";
  FOR X = 1 TO N: LPRINT C$(101 - (T(X) / 2)); "  "; : NEXT X
  LPRINT : LPRINT

  LPRINT "Rev Rotor Initial Setting "; C$(101 - (TR / 2))
  IF Q5$ = "N" THEN GOTO SKIP05       'NO SUPERENCIPHERMENT
  IF TABLENO = 0 THEN GOTO SKIP05     'DITTO
  LPRINT
  LPRINT "Super Encipher Table No.  "; C$(TABLENO)
SKIP05:
  LPRINT
  LPRINT "External Checksum         "; C$(CHECKSUM);
  LPRINT
 
  GOSUB TAB116                        'SEPARATOR LINE
  
  LPRINT

TAB55: '----------------------------- 'SET ROW PRINTING SEQUENCE (E or D)

  W = 0: W1 = 1: W2 = 1: W3 = 1: W4 = 2
 
  IF Q$ = "2" THEN SWAP I(1), K(1)    'FOR CORRECT PRINTING SEQUENCE
  IF Q$ = "2" THEN SWAP W3, W4        '   (DECIPHERMENT)
 
  FOR X3 = 1 TO 6                     'PRINT 6 LINES PER SCREEN

     X6 = X6 + 1                      'TOTAL ROWS TALLY

     IF Z$ = "\" AND MID$(I(1), W1, 2) = "  " THEN
       X6 = X6 - 1
       EXIT FOR                       'STOP PRINTING
     END IF

        FOR Y4 = 1 TO 27              'PRINT LINE 1
          LPRINT USING "\ \"; MID$(K(1), W2, W3);
        
          IF Q$ = "1" THEN GOTO SKIP06                '1ST LINE ALPHA (ENC)
             C4(Y4) = C4(Y4) + VAL(MID$(K(1), W2, W3))  'COLUMN ACCUMULATE
             R4(X6) = R4(X6) + VAL(MID$(K(1), W2, W3))  'ROW ACCUMULATE
SKIP06:
          W2 = W2 + W3
        NEXT Y4
     LPRINT : LPRINT
    
     FOR Y3 = 1 TO 27                 'PRINT LINE 2
       LPRINT USING "\ \"; MID$(I(1), W1, W4);
       
       IF Q$ = "2" THEN GOTO SKIP07   '2ND LINE ALPHA (DEC)

       C4(Y3) = C4(Y3) + VAL(MID$(I(1), W1, W4))  'COLUMN ACCUMULATE
       R4(X6) = R4(X6) + VAL(MID$(I(1), W1, W4))  'ROW ACCUMULATE
SKIP07:
       W1 = W1 + W4
     NEXT Y3
     LPRINT : LPRINT
    
     GOSUB TAB116                     'SEPARATOR LINE
     LPRINT
    
  NEXT X3

  K1 = K1 + K                         'ACCUMULATE INPUT COUNT
  I1 = I1 + I

  I9 = I9 + 1                         'OUTPUT ARRAY COUNTER
  I4(I9) = I(1)                       'STORE OUTPUT FOR MESSAGE FORMAT
  I(1) = "": K(1) = ""
 
  IF A1$ = "\" OR B$ = "\" THEN GOTO TAB30       'END SESSION
  F1 = FRE("")
  RETURN
 
TAB59:  '----------------------------- SET PLUGBOARD

  FOR N8 = 1 TO 100: E1(N8) = 0: NEXT N8

  LOCATE 3, 13
  COLOR 14, 0

  INPUT "SOI : ENTER THE NUMBER PLUGBOARD CONNECTIONS TO SET :  ", N1

  COLOR 7, 0
  IF N1 > 50 THEN
    BEEP
    GOTO TAB59
  END IF

  CHECKSUM1 = CHECKSUM1 + N1

  LOCATE 17, 23
  PRINT "Plugboard Positions not yet selected"

  P1$ = P0$
  Z10 = 1
  FOR N7 = 1 TO 5
    LOCATE , 12
    FOR N9 = 1 TO 20
      LOCATE 18 + N7
      PRINT MID$(P1$, Z10, 2); " ";
      Z10 = Z10 + 2
    NEXT N9: PRINT
  NEXT N7

  N6 = 5
  FOR X = 1 TO N1
    N5 = N5 + 1
    IF N5 > 10 THEN
      N5 = 1
      N6 = N6 + 15
    END IF
    
REENTER:
    LOCATE 5 + N5, N6
    PRINT USING "SET ## : "; X;
    INPUT "", B3$
    IF LEN(B3$) <> 4 THEN GOTO REENTER
    LOCATE 2, 15
    PRINT STRING$(45, " ")
    B1$ = MID$(B3$, 1, 2)             '1ST NUMBER
    B2$ = MID$(B3$, 3, 2)             '2ND NUMBER

      IF B1$ = B2$ THEN
        BEEP
        GOTO REENTER
      END IF

    B11 = VAL(B1$): IF B11 = 0 THEN B11 = 100
    B12 = VAL(B2$): IF B12 = 0 THEN B12 = 100

    IF E1(B11) = 0 AND E1(B12) = 0 THEN   'CHECK FOR DUPLICATION
       E1(B11) = B11
       E1(B12) = B12
    ELSE
       BEEP
       LOCATE 2, 20
       COLOR 30, 0
       PRINT "Duplicate Plug connection.  Re-enter."
       COLOR 7, 0
       GOTO REENTER
    END IF

    PB$(X) = B3$                      'STORE CONNECTIONS FOR LISTING

    S = 1
    FOR U = 1 TO 200 STEP 2
      IF B1$ = MID$(Z1$, U, 2) THEN EXIT FOR
      S = S + 2
    NEXT U

    T = 1
    FOR U = 1 TO 200 STEP 2
      IF B2$ = MID$(Z1$, U, 2) THEN EXIT FOR
      T = T + 2
    NEXT U

    MID$(Z2$, S, 2) = MID$(Z1$, T, 2)
    MID$(Z2$, T, 2) = MID$(Z1$, S, 2)
    CHECKSUM1 = CHECKSUM1 + (B11 * B12)
    IF B1$ = "00" THEN B1$ = "100"
    IF B2$ = "00" THEN B2$ = "100"
    MID$(P1$, (VAL(B1$) * 2) - 1, 2) = "  "
    MID$(P1$, (VAL(B2$) * 2) - 1, 2) = "  "

    Z10 = 1
    FOR N7 = 1 TO 5
      LOCATE , 12
      FOR N9 = 1 TO 20
        LOCATE 18 + N7
        PRINT MID$(P1$, Z10, 2); " ";
        Z10 = Z10 + 2
      NEXT N9: PRINT
    NEXT N7

  NEXT X
  SLEEP 2
  RETURN
 
TAB60:   '---------------------------- THRU PLUGBOARD - ENCIPHER

  S = 1
  IF A$ = "100" THEN A$ = "00"
  FOR U = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
    S = S + 2
  NEXT U

  A$ = MID$(Z2$, S, 2)

  RETURN

TAB62:   '---------------------------- THRU PLUGBOARD - DECIPHER

  S = (L * 2) - 1
  A$ = MID$(Z2$, S, 2)
  IF A$ = "00" THEN A$ = "100"
  L = VAL(A$)

  RETURN
 
TAB64:   '---------------------------- ALPHA SUPER ENCIPHERING

  GOSUB TAB76                         'READ TABLE FROM DISK FILE

  D2 = 1
  FOR B = 1 TO 100
    FOR C2 = 1 TO 8
      F$(B, C2) = MID$(N(1), D2, 2)
      D2 = D2 + 2
    NEXT C2
  NEXT B

  N(1) = ""

  FOR B = 1 TO 100
    FOR C2 = 1 TO 7
      IF F$(B, C2) = "  " THEN GOTO SKIP08
      Z1 = INSTR(M3$, MID$(F$(B, C2), 1, 1))     ' COL CODE - 1ST ALPHA
      Z3 = INSTR(M3$, MID$(F$(B, C2), 2, 1))     ' COL CODE - 2ND ALPHA
      V$ = STR$(B)
      T$ = "00"

      SELECT CASE B                   'CREATE LOCATOR CELL DATA
        CASE 1 TO 9
          MID$(T$, 2, 1) = MID$(V$, 2, 1)
        CASE 10 TO 99
          MID$(T$, 1, 2) = MID$(V$, 2, 2)
        CASE 100
          T$ = "00"
      END SELECT

      J(Z1, Z3) = T$

SKIP08:

    NEXT C2
  NEXT B

  IF Q$ = "2" THEN RETURN             '2 = DECIPHER

TAB66:
  LOCATE 14, 20
  INPUT "SET INITIAL COUNT (1 TO 6)            :   ", SE
  FOR U4 = 1 TO 100
    C(U4) = SE
  NEXT U4
  IF SE < 1 OR SE > 6 THEN
    BEEP
    GOTO TAB66
  END IF

  RETURN
 
TAB70:   '---------------------------- SUPER ENCIPHER INTO ALPHA

  R1 = VAL(J$)                        'ROW No.
  IF J$ = "00" THEN R1 = 100          'ADJUST FOR '00' TO '100'
  IF F$(R1, C(R1)) = "  " THEN C(R1) = 1     'CHECK FOR END OF ROW
  J$ = F$(R1, C(R1))                  'ALPHA SUPERENCIPHERMENT
  C(R1) = C(R1) + 1                   'INCREMENT COL. COUNT

  G1 = INSTR(M3$, MID$(J$, 1, 1))     'POSITION OF 1ST CHARACTER
  G2 = INSTR(M3$, MID$(J$, 2, 1))     'POSITION OF 2ND CHARACTER
  G(G1, G2) = G(G1, G2) + 1           'SUPERENCIPHERMENT TALLY

  RETURN

TAB72:   '---------------------------- SUPER DECIPHERMENT FROM ALPHA

  R3 = INSTR(M3$, MID$(A$, 1, 1))     'ROW
  C3 = INSTR(M3$, MID$(A$, 2, 1))     'COL
  A$ = J(R3, C3)

  RETURN
 
TAB74:       '------------------------ RANDOM ACCESS DISK FILE FOR ROTORS
 
  TYPE ROTORSET
     ROTOR AS STRING * 200
  END TYPE

  DIM ROTORS AS ROTORSET

  OPEN "B:ROTORS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200
 
  FOR X = 1 TO N                      'READ ROTORS FROM DISK

    ROTORNUM = A(X)
    GET #1, ROTORNUM, ROTORS
    R(X) = ROTORS.ROTOR

    FOR X7 = 1 TO 200                 'CHANGE BLANKS TO ZEROS
      IF MID$(R(X), X7, 1) = " " THEN MID$(R(X), X7, 1) = "0"
    NEXT X7

  NEXT X
  
  CLOSE #1
 
  RETURN
 
TAB76:  '----------------------------- GET SUPERENCIPHERMENT TABLES FROM DISK
                              
  CLS
 
  TYPE TABLE
     ALPHA AS STRING * 1600
  END TYPE

  DIM ARRAY AS TABLE
                                                     
  OPEN "B:CODE.DAT" FOR RANDOM AS #1 LEN = 1600

  NUM.RECS = LOF(1) / 1600

  CLS
  IF CORR$ = "Y" THEN GOTO SKIP09
  LOCATE 8, 31
  PRINT "(See current S.O.I)"
  LOCATE 10, 20
  PRINT "SUPERCIPHERMENT TABLES AVAILABLE      :"; NUM.RECS
REENTER3:
  LOCATE 12, 20
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT "ENTER SUPERENCIPHERMENT TABLE NUMBER  :  ", TABLENO

  IF TABLENO > 100 OR TABLENO < 1 THEN
    BEEP
    GOTO REENTER3
  END IF

  CHECKSUM = CHECKSUM + TABLENO
   
  COLOR 7, 0                          'WHITE/BLACK
SKIP09:
  GET #1, TABLENO, ARRAY
  CLOSE #1

  N(1) = ARRAY.ALPHA
  
  RETURN
 
TAB78:        '----------------------- COUNT INPUT
  
  M4 = INSTR(M3$, B$)                 'NORMAL SEQUENTIAL VALUE OF INPUT
  M4$ = C$(M4)
  B(VAL(M4$)) = B(VAL(M4$)) + 1

  RETURN

TAB80:        '----------------------- COUNT OUTPUT

  J1$ = J$
  IF J$ = "00" THEN J1$ = "100"
  D(VAL(J1$)) = D(VAL(J1$)) + 1

  RETURN

TAB82:        '----------------------- PRINT INPUT FREQUENCY ANALYSIS

  CLS
  LPRINT CHR$(12);                    'FORM FEED

  LPRINT TAB(31);
  LPRINT "INPUT FREQUENCY ANALYSIS"
  LPRINT
  LPRINT "| Char    Freq  |  Char    Freq  |  Char    Freq  |  Char    Freq  |  Char    Freq  |"
  LPRINT "| ----    ----  |  ----    ----  |  ----    ----  |  ----    ----  |   ----    ---- |"

  FOR R = 1 TO 20

    N1$ = STR$(B(R)): IF N1$ = " 0" THEN N1$ = "   "
    N2$ = STR$(B(R + 20)): IF N2$ = " 0" THEN N2$ = "   "
    N3$ = STR$(B(R + 40)): IF N3$ = " 0" THEN N3$ = "   "
    N4$ = STR$(B(R + 60)): IF N4$ = " 0" THEN N4$ = "   "
    N5$ = STR$(B(R + 80)): IF N5$ = " 0" THEN N5$ = "   "
   
    LPRINT USING "|   \\    \  \  |  "; MID$(M3$, R, 1); N1$;
    IF R + 20 <> 37 THEN GOTO BYPASS1
    LPRINT USING "space   \  \  |  "; N2$;
    GOTO BYPASS2
BYPASS1:
    LPRINT USING "  \\    \  \  |  "; MID$(M3$, R + 20, 1); N2$;
   
BYPASS2:
    LPRINT USING "  \\    \  \  |  "; MID$(M3$, R + 40, 1); N3$;
   
    LPRINT USING "  \\    \  \  |  "; MID$(M3$, R + 60, 1); N4$;
   
    LPRINT USING "  \\    \  \  |  "; MID$(M3$, R + 80, 1); N5$;

    LPRINT
  NEXT R

  N10 = 0
  FOR X = 1 TO 100
    N10 = N10 + B(X)
  NEXT X

  LPRINT
  LPRINT "Total = "; N10
  F1 = FRE("")
  RETURN

TAB84:    '--------------------------- PRINT OUTPUT FREQUENCY ANALYSIS

  CLS
  LPRINT : LPRINT
  LPRINT TAB(31); "OUTPUT FREQUENCY ANALYSIS"
  LPRINT
  L1$ = "   Code Count       Code Count       Code Count       Code Count       Code Count"
  LPRINT L1$
  L2$ = "|---------------|----------------|----------------|----------------|----------------|"
  LPRINT L2$

  FOR R = 1 TO 20

    N1$ = STR$(D(R)): IF N1$ = " 0" THEN N1$ = "  "
    N2$ = STR$(D(R + 20)): IF N2$ = " 0" THEN N2$ = "  "
    N3$ = STR$(D(R + 40)): IF N3$ = " 0" THEN N3$ = "  "
    N4$ = STR$(D(R + 60)): IF N4$ = " 0" THEN N4$ = "  "
    N5$ = STR$(D(R + 80)): IF N5$ = " 0" THEN N5$ = "  "

    LPRINT USING "|   ## = \ \    |"; R; N1$;
    LPRINT USING "    ## = \ \    |"; R + 20; N2$;
    LPRINT USING "    ## = \ \    |"; R + 40; N3$;
    LPRINT USING "    ## = \ \    |"; R + 60; N4$;
    IF R + 80 = 100 THEN GOTO SKIP10
    LPRINT USING "    ## = \ \    |"; R + 80; N5$;
    GOTO SKIP11
SKIP10:
    LPRINT USING "    00 = \ \    |"; N5$;
SKIP11:
    LPRINT
  NEXT R

  N11 = 0
  FOR X = 1 TO 100
    N11 = N11 + D(X)
  NEXT X
  LPRINT : LPRINT "Total = "; N11
  F1 = FRE("")
  RETURN
 
TAB93:       '------------------------ GET REVERSING ROTORS FROM DISK FILE
 
  TYPE REVROTRSET
       REVROTR AS STRING * 200
  END TYPE

  DIM REVROTRS AS REVROTRSET

  OPEN "B:REVROTRS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200
 
  PRINT
  IF CORR$ = "Y" THEN GOTO SKIP13

REPEAT07:
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT ; "ENTER REVERSING ROTOR NUMBER (1 TO 100) : ", REVROTRNUM

  IF REVROTRNUM > 100 OR REVROTRNUM < 1 THEN
    BEEP
    GOTO REPEAT07
  END IF

  COLOR 7, 0                          'WHITE/BLACK
  PRINT

SKIP13:
  GET #1, REVROTRNUM, REVROTRS        'READ REVERSING ROTOR FROM DISK
  PRINT

  A6$ = REVROTRS.REVROTR              'ASSIGN REVERSING ROTOR TO A6$

  CLOSE #1
  CHECKSUM1 = CHECKSUM1 + REVROTRNUM
  SLEEP 2

  RETURN                              'TO TAB3
 
TAB96:  '----------------------------- GET CHARACTER SET FROM DISK FILE
                                 
  CLS

  IF ANOTHER$ = "Y" THEN              'Y = KEEP ORIGINAL CHARACTER SET
    Y4$ = Y$
    ANOTHER$ = "N"
    RETURN
  END IF

  TYPE CHARSET
     CHAR AS STRING * 100
  END TYPE

  DIM CHARS AS CHARSET
                                                    
  OPEN "B:CHARS.DAT" FOR RANDOM AS #1 LEN = 100

  NUM.RECS = LOF(1) / 100

REPEAT08:
  CLS
  LOCATE 10, 26
  PRINT NUM.RECS; "CHARACTER SETS AVAILABLE"
  PRINT
  LOCATE 12, 33
  PRINT "(See your list)"
  LOCATE 14, 28
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT "ENTER CHARACTER SET NUMBER ", CHARNUM
  COLOR 7, 0                          'WHITE/BLACK

  IF CHARNUM > 100 OR CHARNUM < 1 THEN   'CHECK FOR INVALID CHARNUM
    BEEP
    GOTO REPEAT08
  END IF

  COLOR 7, 0                          'WHITE/BLACK
  CHECKSUM1 = CHECKSUM1 + CHARNUM
  SLEEP 2

  GET #1, CHARNUM, CHARS

  CLOSE #1

  Y$ = CHARS.CHAR
  Y4$ = Y$                            'PRESERVE Y$ FOR NEXT MESSAGES STARTS
  GOSUB TAB115                        'ENTER ROTATIONAL SHIFT VALUE
  
  RETURN
 
TAB98:  '----------------------------- PRINT ANALYSIS OF SUPERENCIPHERMENT

  LPRINT TAB(31); "OUTPUT FREQUENCY ANALYSIS"
  LPRINT
  LPRINT "\2  ";                      'HEADER ROW (A-Z)

  FOR X = 1 TO 26
    LPRINT USING "\ \"; MID$(M3$, X, 1);
  NEXT X
  LPRINT USING "\   \"; "Total"

  LPRINT "1\";                        'HEADER ROW (--)
  FOR X = 1 TO 26
    LPRINT USING "\ \"; " --";
  NEXT X
  LPRINT USING "\     \"; "  -----"
  
  FOR X = 1 TO 26                     'DATA ROW
    LPRINT USING "\\"; MID$(M3$, X, 1);

    FOR Y = 1 TO 26
   
      IF G(X, Y) = 0 THEN
        LPRINT USING "\ \"; "   ";    'BLANK
        GOTO SKIP14
      END IF

      LPRINT USING "###"; G(X, Y);    'COUNT
      G3 = G3 + G(X, Y)               'ROW TALLY

SKIP14:
      H(Y) = H(Y) + G(X, Y)           'COL TALLY
    NEXT Y

    IF G3 = 0 THEN
      LPRINT USING "\ \"; "   "
      GOTO SKIP15
    END IF

    LPRINT USING " #####"; G3         'ROW TOTAL
    G4 = G4 + G3                      'ACCUMULATE GRAND TOTAL
    G3 = 0

SKIP15:
    NEXT X

  LPRINT "  ";                        'TOTAL ROW (--)
  FOR X = 1 TO 26
    LPRINT USING "\ \"; " --";
  NEXT X
  LPRINT USING "\     \"; "  -----"

  LPRINT "    ";                      'TOTAL ROW (A-Z)
  FOR X = 1 TO 26
    LPRINT USING "\ \"; MID$(M3$, X, 1);
  NEXT X
  LPRINT USING "\   \"; "Total"

  LPRINT "  ";                        'TOTAL ROW (--)
  FOR X = 1 TO 26
    LPRINT USING "\ \"; " --";
  NEXT X
  LPRINT USING "\     \"; "  -----"

  LPRINT "  ";                        'COL TOTALS
  FOR Y = 1 TO 26
    IF H(Y) = 0 THEN
      LPRINT USING "\ \"; "   ";
      GOTO SKIP16
    END IF
    LPRINT USING " ##"; H(Y);
SKIP16:
  NEXT Y
 
  LPRINT USING "  ####"; G4
  F1 = FRE("")
  RETURN
 
TAB102: '----------------------------- PUT MESSAGE IN TRANSMISION FORMAT
                                      
  LPRINT CHR$(12);                    'FORM FEED
  LPRINT TAB(25); "FOR TRANSMISSION AS MESSAGE No."
  LPRINT
  GOSUB TAB116                        'SEPARATOR LINE
 
  FOR X = 1 TO N                      'PRINT ROTOR NUMBERS
    LPRINT C$(101 - (T(X) / 2)); " ";
  NEXT X
  LPRINT C$(101 - (TR / 2));          'PRINT REVERSING ROTOR NUMBER
  IF TABLENO = 0 THEN GOTO SKIP17
  LPRINT " "; C$(TABLENO);            'SUPERENCIPHERMENT TABLE No.

SKIP17:
  LPRINT " "; C$(CHECKSUM);           'SETTINGS CHECK DIGIT SUM
  LPRINT TAB(64); D11$; " "; T11$     'PRINT DATE / TIME

  GOSUB TAB116
  LPRINT

  FOR X = 1 TO I9                     'PRINT MESSAGE CODE
    I8 = 1
    FOR Y = 1 TO 6                    'PRINT 1 SCREENFUL
      FOR Z = 1 TO 27
        LPRINT USING "\\ "; MID$(I4(X), I8, 2);
        I8 = I8 + 2
        IF MID$(I4(X), I8, 2) = "  " THEN EXIT FOR
      NEXT Z
      LPRINT : LPRINT
      IF MID$(I4(X), I8, 2) = "  " THEN EXIT FOR
    NEXT Y
    IF MID$(I4(X), I8, 2) = "  " THEN EXIT FOR
  NEXT X
   
  LPRINT : LPRINT : LPRINT K1;        'PRINT TOTAL CHARACTERS
  IF Q5$ = "Y" THEN GOTO SKIP19       'SKIP IF SUPERENCIPHERED
  LPRINT "    "; C$(HC)               'HASH TOTAL

  GOSUB TAB116                        'SEPARATOR LINE
 
  FOR X = 1 TO 27                     'PRINT COL CHECK TOTALS
    X9 = X9 + C4(X)
    A = C4(X) / 100
    B = INT(A)
    C = (A - B) * 100
    IF C = 0 THEN C = 100
    IF C4(X) = 0 THEN
      LPRINT USING "\\ "; "  ";
      GOTO SKIP18
    END IF
    LPRINT USING "\\ "; C$(C);
SKIP18:
  NEXT X
  LPRINT : LPRINT

  FOR X = 1 TO X6                     'PRINT ROW CHECK TOTALS
    Y6 = Y6 + 1                       'LINE POSITION COUNTER
    X8 = X8 + R4(X)
    A = R4(X) / 100
    B = INT(A)
    R = (A - B) * 100
    IF R = 0 THEN R = 100
    IF Y6 = 28 THEN                   'LIMIT LINE TO 27 POSITIONS
      LPRINT : LPRINT
      Y6 = 0
    END IF
    LPRINT USING "\\ "; C$(R);
  NEXT X
  LPRINT
 
SKIP19:
  F1 = FRE("")
  RETURN

TAB106:    '---------------------------- SAVE DUPLICATE OF ROTORS

  F5 = 1                              'FLAG TO INDICATE THIS ACTION
  U2 = U1                             'INPUT COUNT START FOR NEXT SCREEN
  M5 = 0                              'RESET COUNTER
  HC1 = HC                            'SAVE HASH TOTAL
  Y5$ = Y4$                           'SAVE CHARACTER SET

  IF Q5$ = "N" THEN                   'IF NOT SUPERENCIPHERED
    FOR M7 = 1 TO 27
      C5(M7) = C4(M7)                 'SAVE OUTPUT COL.s TALLY
    NEXT M7

    FOR M7 = 1 TO 100
      R5(M7) = R4(M7)                 'SAVE OUTPUT ROWs TALLY
      B1(M7) = B(M7)                  'SAVE INPUT FREQUENCY COUNTER
      D1(M7) = D(M7)                  'SAVE OUTPUT FREQUENCY COUNTER
    NEXT M7
  END IF

  IF Q5$ = "Y" THEN                   'IF SUPERENCIPHEED
    FOR M6 = 1 TO 100
      B1(M6) = B(M6)                  'SAVE INPUT FREQUENCY COUNTER
      C1(M6) = C(M6)                  'SAVE SUPERENCIPHERMENT COL. VALUES
    NEXT M6
  END IF

  R1A(1) = R1(1)                      'SAVE ROTOR POSITIONS
  P1A$ = P0(1)
   
  R1A(2) = R1(2)
  P2A$ = P0(2)

  R1A(3) = R1(3)
  P3A$ = P0(3)
  
  R1A(4) = R1(4)
  P4A$ = P0(4)

  R1A(5) = R1(5)
  P5A$ = P0(5)
  
  R1A(6) = R1(6)
  P6A$ = P0(6)

  R1A(7) = R1(7)
  P7A$ = P0(7)
  
  R1A(8) = R1(8)
  P8A$ = P0(8)

  R1A(9) = R1(9)
  P9A$ = P0(9)
  
  R1A(10) = R1(10)
  P10A$ = P0(10)

  R1A(11) = R1(11)
  P11A$ = P0(11)
  
  R1A(12) = R1(12)
  P12A$ = P0(12)

  RRA$ = RR$
  PRA$ = PR$
 
  FOR G7 = 1 TO 26                    'SUPERENCIPHERMENT OUTPUT ANALYSIS
    FOR G8 = 1 TO 26
      G5(G7, G8) = G(G7, G8)
    NEXT G8
  NEXT G7
 
  RETURN

TAB107:    '---------------------------- RESTORE ROTORS AFTER CORRECTION

  F5 = 0                              'FLAG TO INDICATE THIS ACTION
  U1 = U2                             'INPUT COUNT FROM PRIOR SCREEN
  HC = HC1                            'RESTORE HASH TOTAL
  Y4$ = Y5$                           'RESTORE CHARACTER SET

  IF Q5$ = "N" THEN                   'N = NOT SUPERENCIPHERED
    FOR M7 = 1 TO 27
      C4(M7) = C5(M7)                 'RESTORE OUTPUT COL.s TALLY
    NEXT M7

    FOR M7 = 1 TO 100
      R4(M7) = R5(M7)                 'RESTORE OUTPUT ROWs TALLY
      B(M7) = B1(M7)                  'RESTORE INPUT FREQUENCY COUNTER
      D(M7) = D1(M7)                  'RESTORE OUTPUT FREQUENCY COUNTER
    NEXT M7
  END IF

  IF Q5$ = "Y" THEN                   'Y = SUPERENCIPHERMENT MODE
    FOR M6 = 1 TO 100
      C(M6) = C1(M6)                  'RESTORE SUPERENCIPHERMENT COL. VALUES
      B(M6) = B1(M6)                  'RESTORE INPUT FREQUENCY COUNTER
    NEXT M6
  END IF
    
  R1(1) = R1A(1)                      'RESTORE ROTOR POSITIONS
  P0(1) = P1A$
  
  R1(2) = R1A(2)
  P0(2) = P2A$

  R1(3) = R1A(3)
  P0(3) = P3A$
 
  R1(4) = R1A(4)
  P0(4) = P4A$

  R1(5) = R1A(5)
  P0(5) = P5A$
 
  R1(6) = R1A(6)
  P0(6) = P6A$

  R1(7) = R1A(7)
  P0(7) = P7A$
 
  R1(8) = R1A(8)
  P0(8) = P8A$

  R1(9) = R1A(9)
  P0(9) = P9A$
 
  R1(10) = R1A(10)
  P0(10) = P10A$

  R1(11) = R1A(11)
  P0(11) = P11A$
 
  R1(12) = R1A(12)
  P0(12) = P12A$

  RR$ = RRA$
  PR$ = PRA$
 
  FOR G7 = 1 TO 26                    'SUPERENCIPHERMENT OUTPUT ANALYSIS
    FOR G8 = 1 TO 26
      G(G7, G8) = G5(G7, G8)
    NEXT G8
  NEXT G7
  F1 = FRE("")
  RETURN
 
TAB108:  '---------------------------- POSITION NUMBERS FOR CORRECTIONS

  COLOR 13, 0                         'LT MAGENTA/BLACK

E10(1) = "01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27"
E20(1) = "28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54"
E30(1) = "55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81"
E40(1) = "82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 00 01 02 03 04 05 06 07 08"
E50(1) = "09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35"
E60(1) = "36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62"

  FOR V7 = 1 TO 6

    SELECT CASE V7
      CASE 1
        LOCATE 2, 1
        PRINT E10(1)
      CASE 2
        LOCATE 6, 1
        PRINT E20(1)
      CASE 3
        LOCATE 10, 1
        PRINT E30(1)
      CASE 4
        LOCATE 14, 1
        PRINT E40(1)
      CASE 5
        LOCATE 18, 1
        PRINT E50(1)
      CASE 6
        LOCATE 22, 1
        PRINT E60(1)
    END SELECT

  NEXT V7

  LOCATE 25, 1
  FOR C6 = 1 TO 8: PRINT "          "; : NEXT C6
  LOCATE 25, 1
  INPUT ; "ENTER THE (FIRST) POSITION TO CORRECT ", X2
  F1 = FRE("")
  RETURN

TAB109: '----------------------------- ROTOR DISPLAY AT BOTTOM OF SCREEN
 
  LOCATE 25, 1                        'BOTTOM OF SCREEN
  COLOR 15, 0                         'BRIGHT WHITE/BLACK
  PRINT TAB(25 - (N * 2)); "Rotor Display  ";  'CENTER THE DISPLAY

  FOR V9 = 1 TO N
    COLOR 0, 7                        'BLACK/BRIGHT WHITE
    PRINT USING " \\ "; RB$(V9);
    COLOR 7, 0
    PRINT " ";
  NEXT V9

  COLOR 0, 2                          'BLACK/GREEN
  PRINT USING " \\ "; R13$;           'REVERSING ROTOR
  COLOR 7, 0

  RETURN
 
TAB110: '----------------------------- RANDOM STARTING POSITION SELECTION

  IF Q$ = "2" THEN GOTO SKIP20        'DECRYPTION - SKIP THIS ROUTINE
 
  LOCATE 3, 23
  PRINT "SELECT UP TO 14 RANDOM NUMBERS FOR:"
  LOCATE 5, 23
  PRINT "a - 1 to 12 Initial Rotor Settings"
  LOCATE 7, 23
  PRINT "b - 1 Initial Reversing Rotor Setting"
  LOCATE 9, 23
  PRINT "c - 1 Superencipherment Table Number"
  LOCATE 12, 18
  PRINT "SELECT NUMBERS BY PRESSING ANY KEY ";
  COLOR 30, 0                         'BLINKING YELLOW/BLACK
  PRINT "EXCEPT '1'"
  COLOR 7, 0
  LOCATE 14, 14
  PRINT "(PRESSING THE '1' KEY ENDS THE SELECTION PROCESS)"
  LOCATE 15, 14
  PRINT "(RANDOMNESS IS ACHIEVED BY VARYING THE TIME INTERVAL)"
  LOCATE 16, 14
  PRINT "(WRITE THEM DOWN FOR USE LATER ON IN THIS SESSION)"
  LOCATE 19, 14
  PRINT "01  02  03  04  05  06  07  08  09  10  11  12  13  14"
  LOCATE 20, 14
  PRINT "--  --  --  --  --  --  --  --  --  --  --  --  --  --"

  PRINT TAB(13);
  COLOR 14, 0                         'YELLOW/BLACK

REPEAT09:                             'ROTATE NUMBERS UNTIL KEY IS PRESSED
  DO
    AA$ = MID$(CC$, 1, 2)
    BB$ = MID$(CC$, 3)
    CC$ = BB$ + AA$
    EE$ = INKEY$
  LOOP WHILE EE$ = ""
    IF EE$ = "1" THEN
       RETURN
    ELSE
       DD$ = MID$(CC$, 1, 2)          'SELECT 1ST NUMBER
       CC$ = MID$(CC$, 3)             'REMOVE 1ST NUMBER FROM GROUP
       PRINT USING " \\ "; DD$;       'DISPLAY SELECTED NUMBER
       GOTO REPEAT09                  'REPEAT PROCESS
    END IF

SKIP20:
  AA$ = "": BB$ = "": CC$ = "": DD$ = "": EE$ = ""
  RETURN
 
TAB113:  '---------------------------- CHECKSUM ROUTINE

  CHECKSUM = CHECKSUM + CHECKSUM1
  CHECKSUM = CHECKSUM MOD 100
  IF CHECKSUM = 0 THEN CHECKSUM = 100
  PRINT "CHECKSUM = "; C$(CHECKSUM)
  RETURN
 
TAB114:  '---------------------------- STORE ORIGINAL INTERNAL SETTINGS

  U1 = 0                              'INITIALIZE INPUT COUNTER

  CHECKSUM = 0                        'ADJUST FOR ANOTHER MESSAGE
  H2 = 0
  I9 = 0
  FOR O5 = 1 TO 10
    I4(O5) = ""
  NEXT O5
 
  FOR X = 1 TO N                      'PUT ROTORS IN CORRECT ORDER
                                     
    SELECT CASE X
      CASE 1
         R1(1) = R(X)
         P0(1) = P0$
         IF A$(X) = "2" THEN SWAP R1(1), P0(1)

      CASE 2
         R1(2) = R(X)
         P0(2) = P0$
         IF A$(X) = "2" THEN SWAP R1(2), P0(2)

      CASE 3
         R1(3) = R(X)
         P0(3) = P0$
         IF A$(X) = "2" THEN SWAP R1(3), P0(3)
        
      CASE 4
         R1(4) = R(X)
         P0(4) = P0$
         IF A$(X) = "2" THEN SWAP R1(4), P0(4)
        
      CASE 5
         R1(5) = R(X)
         P0(5) = P0$
         IF A$(X) = "2" THEN SWAP R1(5), P0(5)
        
      CASE 6
         R1(6) = R(X)
         P0(6) = P0$
         IF A$(X) = "2" THEN SWAP R1(6), P0(6)
        
      CASE 7
         R1(7) = R(X)
         P0(7) = P0$
         IF A$(X) = "2" THEN SWAP R1(7), P0(7)
        
      CASE 8
         R1(8) = R(X)
         P0(8) = P0$
         IF A$(X) = "2" THEN SWAP R1(8), P0(8)
        
      CASE 9
         R1(9) = R(X)
         P0(9) = P0$
         IF A$(X) = "2" THEN SWAP R1(9), P0(9)
        
      CASE 10
         R1(10) = R(X)
         P0(10) = P0$
         IF A$(X) = "2" THEN SWAP R1(10), P0(10)
        
      CASE 11
         R1(11) = R(X)
         P0(11) = P0$
         IF A$(X) = "2" THEN SWAP R1(11), P0(11)
        
      CASE 12
         R1(12) = R(X)
         P0(12) = P0$
         IF A$(X) = "2" THEN SWAP R1(12), P0(12)
        
    END SELECT

  NEXT X

  RR$ = A6$                           'REVERSING ROTOR
  PR$ = P0$                           'FRONT OF REVERSING ROTOR
 
  G3 = 0
  G4 = 0
  K1 = 0
  X6 = 0
  X8 = 0
  X9 = 0
  R = 0

  FOR X = 1 TO 27: C4(X) = 0: NEXT X  'COLUMN TALLY

  FOR X = 1 TO 26                     'INITIALIZE ANALYSIS COUNTER
    FOR Y = 1 TO 26
      G(X, Y) = 0
      G5(X, Y) = 0
    NEXT Y
  NEXT X

  W5 = 0                              'INITIALIZE PRINT SWITCH
  HC = 0                              'INITIALIZE HASH COUNT

  FOR X = 0 TO 100                    'INITIALIZE
    R4(X) = 0                         'ROW TALLY
    O(X) = 0                          'INPUT/OUTPUT COUNTER
    C(X) = SE                         'SUPER ENCIPHERMENT COUNTER
    I3(X) = 0
    R5(X) = 0
    B(X) = 0
    B1(X) = 0
    C1(X) = 0
    D(X) = 0
    D1(X) = 0
  NEXT X

  IF ANOTHER$ = "Y" THEN M = 0        'INITIALIZE SETTINGS PRINTING
  F1 = FRE("")
  RETURN

TAB115:  '---------------------------- SELECT CHARACTER SET ROTATIONAL VALUE

  CLS
  LOCATE 1, 18
  PRINT "(See the current S.O.I for the values to use)"
  LOCATE 3, 17
  PRINT "SET ROTATIONAL SHIFT VALUE FOR THE CHARACTER SET"
  LOCATE 5, 21
  PRINT "USING ONE OF THE FOLLOWING PRIME NUMBERS"
  LOCATE 8, 7
  PRINT "0,1,3,7,11,13,17,19,23,29,31,37,41,";
  PRINT "43,47,53,59,61,67,71,73,79,83,89,97"
  PRINT

COLOR 14, 0

RETRY:
  LOCATE 11, 29
  INPUT "ROTATIONAL VALUE  :   ", RV

  FOR U5 = 1 TO 13                    'TEST FOR MATCHING ROTOR ROTATION VALUES
    IF S(U5) = RV THEN                'MATCH FOUND
      BEEP
      GOTO RETRY
      EXIT FOR
    END IF
  NEXT U5

  P2 = 0
  FOR PN = 0 TO 24
    IF P(PN) = RV THEN
      P2 = 1
      EXIT FOR
    END IF
  NEXT PN

  IF P2 = 0 THEN
    BEEP
    GOTO RETRY
  END IF

  CHECKSUM1 = CHECKSUM1 + RV
  SLEEP 1

  RETURN

TAB116:  '---------------------------- PRINT LINE

  FOR V = 1 TO 80: LPRINT "-"; : NEXT V: LPRINT
 
  RETURN

